/[gentoo-x86]/eclass/python.eclass
Gentoo

Diff of /eclass/python.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.65 Revision 1.152
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.65 2009/08/15 23:32:58 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/python.eclass,v 1.152 2012/03/07 04:13:27 floppym Exp $
4 4
5# @ECLASS: python.eclass 5# @ECLASS: python.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# python@gentoo.org 7# Gentoo Python Project <python@gentoo.org>
8# 8# @BLURB: Eclass for Python packages
9# original author: Alastair Tse <liquidx@gentoo.org>
10# @BLURB: A Utility Eclass that should be inherited by anything that deals with Python or Python modules.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# Some useful functions for dealing with python. 10# The python eclass contains miscellaneous, useful functions for Python packages.
13 11
12# Must call inherit before EXPORT_FUNCTIONS to avoid QA warning.
13if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
14inherit multilib 14 inherit multilib
15
16if [[ -n "${NEED_PYTHON}" ]] ; then
17 PYTHON_ATOM=">=dev-lang/python-${NEED_PYTHON}"
18 DEPEND="${PYTHON_ATOM}"
19 RDEPEND="${DEPEND}"
20else
21 PYTHON_ATOM="dev-lang/python"
22fi 15fi
23 16
24if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 17# Export pkg_setup every time to avoid issues with eclass inheritance order.
25 DEPEND="${DEPEND} >=app-admin/eselect-python-20090804" 18if ! has "${EAPI:-0}" 0 1 2 3 || { has "${EAPI:-0}" 2 3 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; }; then
19 EXPORT_FUNCTIONS pkg_setup
26fi 20fi
27 21
28__python_eclass_test() { 22# Avoid processing this eclass more than once.
29 __python_version_extract 2.3 23if [[ -z "${_PYTHON_ECLASS_INHERITED}" ]]; then
30 echo -n "2.3 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR" 24_PYTHON_ECLASS_INHERITED="1"
31 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
32 __python_version_extract 2.3.4
33 echo -n "2.3.4 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
34 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
35 __python_version_extract 2.3.5
36 echo -n "2.3.5 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
37 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
38 __python_version_extract 2.4
39 echo -n "2.4 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
40 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
41 __python_version_extract 2.5b3
42 echo -n "2.5b3 -> PYVER: $PYVER PYVER_MAJOR: $PYVER_MAJOR"
43 echo " PYVER_MINOR: $PYVER_MINOR PYVER_MICRO: $PYVER_MICRO"
44}
45 25
46# @FUNCTION: python_version 26if ! has "${EAPI:-0}" 0 1 2 3 4; then
47# @DESCRIPTION: 27 die "API of python.eclass in EAPI=\"${EAPI}\" not established"
48# Run without arguments and it will export the version of python
49# currently in use as $PYVER; sets PYVER/PYVER_MAJOR/PYVER_MINOR
50__python_version_extract() {
51 local verstr=$1
52 export PYVER_MAJOR=${verstr:0:1}
53 export PYVER_MINOR=${verstr:2:1}
54 if [[ ${verstr:3:1} == . ]]; then
55 export PYVER_MICRO=${verstr:4}
56 fi 28fi
57 export PYVER="${PYVER_MAJOR}.${PYVER_MINOR}"
58}
59 29
60python_version() { 30_CPYTHON2_GLOBALLY_SUPPORTED_ABIS=(2.4 2.5 2.6 2.7)
61 [[ -n "${PYVER}" ]] && return 0 31_CPYTHON3_GLOBALLY_SUPPORTED_ABIS=(3.1 3.2)
62 local tmpstr 32_JYTHON_GLOBALLY_SUPPORTED_ABIS=(2.5-jython)
63 python=${python:-/usr/bin/python} 33_PYPY_GLOBALLY_SUPPORTED_ABIS=(2.7-pypy-1.7 2.7-pypy-1.8)
64 tmpstr="$(${python} -V 2>&1 )" 34_PYTHON_GLOBALLY_SUPPORTED_ABIS=(${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]} ${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]} ${_JYTHON_GLOBALLY_SUPPORTED_ABIS[@]} ${_PYPY_GLOBALLY_SUPPORTED_ABIS[@]})
65 export PYVER_ALL="${tmpstr#Python }"
66 __python_version_extract $PYVER_ALL
67}
68 35
69# @FUNCTION: PYTHON 36# ================================================================================================
70# @USAGE: [-a|--absolute-path] <Python_ABI="${PYTHON_ABI}"> 37# ===================================== HANDLING OF METADATA =====================================
71# @DESCRIPTION: 38# ================================================================================================
72# Get Python interpreter filename for specified Python ABI. If Python_ABI argument 39
73# is ommitted, then PYTHON_ABI environment variable must be set and is used. 40_PYTHON_ABI_PATTERN_REGEX="([[:alnum:]]|\.|-|\*|\[|\])+"
74PYTHON() { 41
75 local absolute_path="0" slot= 42_python_check_python_abi_matching() {
43 local pattern patterns patterns_list="0" PYTHON_ABI
76 44
77 while (($#)); do 45 while (($#)); do
78 case "$1" in 46 case "$1" in
79 -a|--absolute-path) 47 --patterns-list)
80 absolute_path="1" 48 patterns_list="1"
49 ;;
50 --)
51 shift
52 break
81 ;; 53 ;;
82 -*) 54 -*)
83 die "${FUNCNAME}(): Unrecognized option $1" 55 die "${FUNCNAME}(): Unrecognized option '$1'"
84 ;; 56 ;;
85 *) 57 *)
86 break 58 break
87 ;; 59 ;;
88 esac 60 esac
89 shift 61 shift
90 done 62 done
91 63
92 if [[ "$#" -eq "0" ]]; then 64 if [[ "$#" -ne 2 ]]; then
93 if [[ -n "${PYTHON_ABI}" ]]; then 65 die "${FUNCNAME}() requires 2 arguments"
94 slot="${PYTHON_ABI}" 66 fi
67
68 PYTHON_ABI="$1"
69
70 if [[ "${patterns_list}" == "0" ]]; then
71 pattern="$2"
72
73 if [[ "${pattern}" == *"-cpython" ]]; then
74 [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ && "${PYTHON_ABI}" == ${pattern%-cpython} ]]
75 elif [[ "${pattern}" == *"-jython" ]]; then
76 [[ "${PYTHON_ABI}" == ${pattern} ]]
77 elif [[ "${pattern}" == *"-pypy-"* ]]; then
78 [[ "${PYTHON_ABI}" == ${pattern} ]]
95 else 79 else
96 die "${FUNCNAME}(): Invalid usage" 80 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
81 [[ "${PYTHON_ABI}" == ${pattern} ]]
82 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
83 [[ "${PYTHON_ABI%-jython}" == ${pattern} ]]
84 elif [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
85 [[ "${PYTHON_ABI%-pypy-*}" == ${pattern} ]]
86 else
87 die "${FUNCNAME}(): Unrecognized Python ABI '${PYTHON_ABI}'"
97 fi 88 fi
98 elif [[ "$#" -eq "1" ]]; then 89 fi
99 slot="$1" 90 else
91 patterns="${2// /$'\n'}"
92
93 while read pattern; do
94 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
95 return 0
96 fi
97 done <<< "${patterns}"
98
99 return 1
100 fi
101}
102
103_python_package_supporting_installation_for_multiple_python_abis() {
104 if has "${EAPI:-0}" 0 1 2 3 4; then
105 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
106 return 0
100 else 107 else
101 die "${FUNCNAME}(): Invalid usage" 108 return 1
102 fi 109 fi
103
104 if [[ "${absolute_path}" == "1" ]]; then
105 echo -n "/usr/bin/python${slot}"
106 else 110 else
107 echo -n "python${slot}" 111 die "${FUNCNAME}(): Support for EAPI=\"${EAPI}\" not implemented"
112 fi
113}
114
115# @ECLASS-VARIABLE: PYTHON_DEPEND
116# @DESCRIPTION:
117# Specification of dependency on dev-lang/python.
118# Syntax:
119# PYTHON_DEPEND: [[!]USE_flag? ]<version_components_group>[ version_components_group]
120# version_components_group: <major_version[:[minimal_version][:maximal_version]]>
121# major_version: <2|3|*>
122# minimal_version: <minimal_major_version.minimal_minor_version>
123# maximal_version: <maximal_major_version.maximal_minor_version>
124
125_python_parse_PYTHON_DEPEND() {
126 local major_version maximal_version minimal_version python_all="0" python_maximal_version python_minimal_version python_versions=() python2="0" python2_maximal_version python2_minimal_version python3="0" python3_maximal_version python3_minimal_version USE_flag= version_components_group version_components_group_regex version_components_groups
127
128 version_components_group_regex="(2|3|\*)(:([[:digit:]]+\.[[:digit:]]+)?(:([[:digit:]]+\.[[:digit:]]+)?)?)?"
129 version_components_groups="${PYTHON_DEPEND}"
130
131 if [[ "${version_components_groups}" =~ ^((\!)?[[:alnum:]_-]+\?\ )?${version_components_group_regex}(\ ${version_components_group_regex})?$ ]]; then
132 if [[ "${version_components_groups}" =~ ^(\!)?[[:alnum:]_-]+\? ]]; then
133 USE_flag="${version_components_groups%\? *}"
134 version_components_groups="${version_components_groups#* }"
108 fi 135 fi
109} 136 if [[ "${version_components_groups}" =~ ("*".*" "|" *"|^2.*\ (2|\*)|^3.*\ (3|\*)) ]]; then
110 137 die "Invalid syntax of PYTHON_DEPEND: Incorrectly specified groups of versions"
111# @FUNCTION: validate_PYTHON_ABIS
112# @DESCRIPTION:
113# Make sure PYTHON_ABIS variable has valid value.
114validate_PYTHON_ABIS() {
115 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
116 if [[ "$(readlink /usr/bin/python)" != "python-wrapper" ]]; then
117 die "/usr/bin/python isn't valid symlink"
118 fi 138 fi
119 if [[ "$(</usr/bin/python-config)" != *"Gentoo python-config wrapper script"* ]]; then
120 die "/usr/bin/python-config isn't valid script"
121 fi
122 139
123 # USE_${ABI_TYPE^^} and RESTRICT_${ABI_TYPE^^}_ABIS variables hopefully will be included in EAPI >= 4. 140 version_components_groups="${version_components_groups// /$'\n'}"
124 if [[ -z "${PYTHON_ABIS}" ]] && has "${EAPI:-0}" 0 1 2 3; then 141 while read version_components_group; do
125 local ABI support_ABI supported_PYTHON_ABIS= restricted_ABI 142 major_version="${version_components_group:0:1}"
126 PYTHON_ABI_SUPPORTED_VALUES="2.4 2.5 2.6 2.7 3.0 3.1 3.2" 143 minimal_version="${version_components_group:2}"
127 for ABI in ${USE_PYTHON}; do 144 minimal_version="${minimal_version%:*}"
128 if ! has "${ABI}" ${PYTHON_ABI_SUPPORTED_VALUES}; then 145 maximal_version="${version_components_group:$((3 + ${#minimal_version}))}"
129 ewarn "Ignoring unsupported Python ABI '${ABI}'" 146
130 continue 147 if [[ "${major_version}" =~ ^(2|3)$ ]]; then
148 if [[ -n "${minimal_version}" && "${major_version}" != "${minimal_version:0:1}" ]]; then
149 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' not in specified group of versions"
131 fi 150 fi
132 support_ABI="1" 151 if [[ -n "${maximal_version}" && "${major_version}" != "${maximal_version:0:1}" ]]; then
133 for restricted_ABI in ${RESTRICT_PYTHON_ABIS}; do 152 die "Invalid syntax of PYTHON_DEPEND: Maximal version '${maximal_version}' not in specified group of versions"
134 if python -c "from fnmatch import fnmatch; exit(not fnmatch('${ABI}', '${restricted_ABI}'))"; then 153 fi
135 support_ABI="0" 154 fi
136 break 155
156 if [[ "${major_version}" == "2" ]]; then
157 python2="1"
158 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
159 python2_minimal_version="${minimal_version}"
160 python2_maximal_version="${maximal_version}"
161 elif [[ "${major_version}" == "3" ]]; then
162 python3="1"
163 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
164 python3_minimal_version="${minimal_version}"
165 python3_maximal_version="${maximal_version}"
166 else
167 python_all="1"
168 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
169 python_minimal_version="${minimal_version}"
170 python_maximal_version="${maximal_version}"
171 fi
172
173 if [[ -n "${minimal_version}" ]] && ! has "${minimal_version}" "${python_versions[@]}"; then
174 die "Invalid syntax of PYTHON_DEPEND: Unrecognized minimal version '${minimal_version}'"
175 fi
176 if [[ -n "${maximal_version}" ]] && ! has "${maximal_version}" "${python_versions[@]}"; then
177 die "Invalid syntax of PYTHON_DEPEND: Unrecognized maximal version '${maximal_version}'"
178 fi
179
180 if [[ -n "${minimal_version}" && -n "${maximal_version}" && "${minimal_version}" > "${maximal_version}" ]]; then
181 die "Invalid syntax of PYTHON_DEPEND: Minimal version '${minimal_version}' greater than maximal version '${maximal_version}'"
182 fi
183 done <<< "${version_components_groups}"
184
185 _PYTHON_ATOMS=()
186
187 _append_accepted_versions_range() {
188 local accepted_version="0" i
189 for ((i = "${#python_versions[@]}"; i >= 0; i--)); do
190 if [[ "${python_versions[${i}]}" == "${python_maximal_version}" ]]; then
191 accepted_version="1"
192 fi
193 if [[ "${accepted_version}" == "1" ]]; then
194 _PYTHON_ATOMS+=("=dev-lang/python-${python_versions[${i}]}*")
195 fi
196 if [[ "${python_versions[${i}]}" == "${python_minimal_version}" ]]; then
197 accepted_version="0"
137 fi 198 fi
138 done 199 done
139 [[ "${support_ABI}" == "1" ]] && supported_PYTHON_ABIS+=" ${ABI}" 200 }
201
202 if [[ "${python_all}" == "1" ]]; then
203 if [[ -z "${python_minimal_version}" && -z "${python_maximal_version}" ]]; then
204 _PYTHON_ATOMS+=("dev-lang/python")
205 else
206 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
207 python_minimal_version="${python_minimal_version:-${python_versions[0]}}"
208 python_maximal_version="${python_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
209 _append_accepted_versions_range
210 fi
211 else
212 if [[ "${python3}" == "1" ]]; then
213 if [[ -z "${python3_minimal_version}" && -z "${python3_maximal_version}" ]]; then
214 _PYTHON_ATOMS+=("=dev-lang/python-3*")
215 else
216 python_versions=("${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}")
217 python_minimal_version="${python3_minimal_version:-${python_versions[0]}}"
218 python_maximal_version="${python3_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
219 _append_accepted_versions_range
220 fi
221 fi
222 if [[ "${python2}" == "1" ]]; then
223 if [[ -z "${python2_minimal_version}" && -z "${python2_maximal_version}" ]]; then
224 _PYTHON_ATOMS+=("=dev-lang/python-2*")
225 else
226 python_versions=("${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}")
227 python_minimal_version="${python2_minimal_version:-${python_versions[0]}}"
228 python_maximal_version="${python2_maximal_version:-${python_versions[${#python_versions[@]}-1]}}"
229 _append_accepted_versions_range
230 fi
231 fi
232 fi
233
234 unset -f _append_accepted_versions_range
235
236 if [[ "${#_PYTHON_ATOMS[@]}" -gt 1 ]]; then
237 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
238 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }|| ( ${_PYTHON_ATOMS[@]} )${USE_flag:+ )}"
239 else
240 DEPEND+="${DEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
241 RDEPEND+="${RDEPEND:+ }${USE_flag}${USE_flag:+? ( }${_PYTHON_ATOMS[@]}${USE_flag:+ )}"
242 fi
243 else
244 die "Invalid syntax of PYTHON_DEPEND"
245 fi
246}
247
248DEPEND=">=app-admin/eselect-python-20091230"
249RDEPEND="${DEPEND}"
250
251if [[ -n "${PYTHON_DEPEND}" ]]; then
252 _python_parse_PYTHON_DEPEND
253else
254 _PYTHON_ATOMS=("dev-lang/python")
255fi
256unset -f _python_parse_PYTHON_DEPEND
257
258if [[ -n "${NEED_PYTHON}" ]]; then
259 eerror "Use PYTHON_DEPEND variable instead of NEED_PYTHON variable."
260 die "NEED_PYTHON variable is banned"
261fi
262
263# @ECLASS-VARIABLE: PYTHON_USE_WITH
264# @DESCRIPTION:
265# Set this to a space separated list of USE flags the Python slot in use must be built with.
266
267# @ECLASS-VARIABLE: PYTHON_USE_WITH_OR
268# @DESCRIPTION:
269# Set this to a space separated list of USE flags of which one must be turned on for the slot in use.
270
271# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT
272# @DESCRIPTION:
273# Set this to a name of a USE flag if you need to make either PYTHON_USE_WITH or
274# PYTHON_USE_WITH_OR atoms conditional under a USE flag.
275
276if ! has "${EAPI:-0}" 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then
277 _PYTHON_USE_WITH_ATOMS_ARRAY=()
278 if [[ -n "${PYTHON_USE_WITH}" ]]; then
279 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
280 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${PYTHON_USE_WITH// /,}]")
140 done 281 done
141 export PYTHON_ABIS="${supported_PYTHON_ABIS# }" 282 elif [[ -n "${PYTHON_USE_WITH_OR}" ]]; then
142 fi 283 for _USE_flag in ${PYTHON_USE_WITH_OR}; do
143
144 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
145 python_version
146 export PYTHON_ABIS="${PYVER}"
147 fi
148}
149
150# @FUNCTION: python_copy_sources
151# @USAGE: [directory]
152# @DESCRIPTION:
153# Copy unpacked sources of given package for each Python ABI.
154python_copy_sources() {
155 local dir dirs=() PYTHON_ABI
156
157 if [[ "$#" -eq "0" ]]; then
158 if [[ "${WORKDIR}" == "${S}" ]]; then
159 die "${FUNCNAME}() cannot be used"
160 fi
161 dirs="${S}"
162 else
163 dirs="$@"
164 fi
165
166 validate_PYTHON_ABIS
167 for PYTHON_ABI in ${PYTHON_ABIS}; do 284 for _PYTHON_ATOM in "${_PYTHON_ATOMS[@]}"; do
168 for dir in "${dirs[@]}"; do 285 _PYTHON_USE_WITH_ATOMS_ARRAY+=("${_PYTHON_ATOM}[${_USE_flag}]")
169 cp -lpr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed" 286 done
170 done 287 done
288 unset _USE_flag
289 fi
290 if [[ "${#_PYTHON_USE_WITH_ATOMS_ARRAY[@]}" -gt 1 ]]; then
291 _PYTHON_USE_WITH_ATOMS="|| ( ${_PYTHON_USE_WITH_ATOMS_ARRAY[@]} )"
292 else
293 _PYTHON_USE_WITH_ATOMS="${_PYTHON_USE_WITH_ATOMS_ARRAY[@]}"
294 fi
295 if [[ -n "${PYTHON_USE_WITH_OPT}" ]]; then
296 _PYTHON_USE_WITH_ATOMS="${PYTHON_USE_WITH_OPT}? ( ${_PYTHON_USE_WITH_ATOMS} )"
297 fi
298 DEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
299 RDEPEND+=" ${_PYTHON_USE_WITH_ATOMS}"
300 unset _PYTHON_ATOM _PYTHON_USE_WITH_ATOMS _PYTHON_USE_WITH_ATOMS_ARRAY
301fi
302
303unset _PYTHON_ATOMS
304
305# ================================================================================================
306# =================================== MISCELLANEOUS FUNCTIONS ====================================
307# ================================================================================================
308
309_python_implementation() {
310 if [[ "${CATEGORY}/${PN}" == "dev-lang/python" ]]; then
311 return 0
312 elif [[ "${CATEGORY}/${PN}" == "dev-java/jython" ]]; then
313 return 0
314 elif [[ "${CATEGORY}/${PN}" == "dev-python/pypy" ]]; then
315 return 0
316 else
317 return 1
318 fi
319}
320
321_python_abi-specific_local_scope() {
322 [[ " ${FUNCNAME[@]:2} " =~ " "(_python_final_sanity_checks|python_execute_function|python_mod_optimize|python_mod_cleanup)" " ]]
323}
324
325_python_initialize_prefix_variables() {
326 if has "${EAPI:-0}" 0 1 2; then
327 if [[ -n "${ROOT}" && -z "${EROOT}" ]]; then
328 EROOT="${ROOT%/}${EPREFIX}/"
329 fi
330 if [[ -n "${D}" && -z "${ED}" ]]; then
331 ED="${D%/}${EPREFIX}/"
332 fi
333 fi
334}
335
336unset PYTHON_SANITY_CHECKS_EXECUTED PYTHON_SKIP_SANITY_CHECKS
337
338_python_initial_sanity_checks() {
339 if [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
340 # Ensure that /usr/bin/python and /usr/bin/python-config are valid.
341 if [[ "$(readlink "${EPREFIX}/usr/bin/python")" != "python-wrapper" ]]; then
342 eerror "'${EPREFIX}/usr/bin/python' is not valid symlink."
343 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
344 die "'${EPREFIX}/usr/bin/python' is not valid symlink"
345 fi
346 if [[ "$(<"${EPREFIX}/usr/bin/python-config")" != *"Gentoo python-config wrapper script"* ]]; then
347 eerror "'${EPREFIX}/usr/bin/python-config' is not valid script"
348 eerror "Use \`eselect python set \${python_interpreter}\` to fix this problem."
349 die "'${EPREFIX}/usr/bin/python-config' is not valid script"
350 fi
351 fi
352}
353
354_python_final_sanity_checks() {
355 if ! _python_implementation && [[ "$(declare -p PYTHON_SANITY_CHECKS_EXECUTED 2> /dev/null)" != "declare -- PYTHON_SANITY_CHECKS_EXECUTED="* || " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " && -z "${PYTHON_SKIP_SANITY_CHECKS}" ]]; then
356 local PYTHON_ABI="${PYTHON_ABI}"
357 for PYTHON_ABI in ${PYTHON_ABIS-${PYTHON_ABI}}; do
358 # Ensure that appropriate version of Python is installed.
359 if ! has_version "$(python_get_implementational_package)"; then
360 die "$(python_get_implementational_package) is not installed"
361 fi
362
363 # Ensure that EPYTHON variable is respected.
364 if [[ "$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")" != "${PYTHON_ABI}" ]]; then
365 eerror "Path to 'python': '$(type -p python)'"
366 eerror "ABI: '${ABI}'"
367 eerror "DEFAULT_ABI: '${DEFAULT_ABI}'"
368 eerror "EPYTHON: '$(PYTHON)'"
369 eerror "PYTHON_ABI: '${PYTHON_ABI}'"
370 eerror "Locally active version of Python: '$(EPYTHON="$(PYTHON)" python -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")'"
371 die "'python' does not respect EPYTHON variable"
372 fi
171 done 373 done
374 fi
375 PYTHON_SANITY_CHECKS_EXECUTED="1"
172} 376}
173 377
174# @FUNCTION: python_set_build_dir_symlink 378# @ECLASS-VARIABLE: PYTHON_COLORS
175# @USAGE: [directory="build"]
176# @DESCRIPTION: 379# @DESCRIPTION:
177# Create build directory symlink. 380# User-configurable colored output.
178python_set_build_dir_symlink() { 381PYTHON_COLORS="${PYTHON_COLORS:-0}"
179 local dir="$1"
180 382
181 [[ -z "${PYTHON_ABIS}" ]] && die "PYTHON_ABIS variable not set" 383_python_set_color_variables() {
182 [[ -z "${dir}" ]] && dir="build" 384 if [[ "${PYTHON_COLORS}" != "0" && "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then
385 _BOLD=$'\e[1m'
386 _RED=$'\e[1;31m'
387 _GREEN=$'\e[1;32m'
388 _BLUE=$'\e[1;34m'
389 _CYAN=$'\e[1;36m'
390 _NORMAL=$'\e[0m'
391 else
392 _BOLD=
393 _RED=
394 _GREEN=
395 _BLUE=
396 _CYAN=
397 _NORMAL=
398 fi
399}
183 400
184 # Don't delete preexistent directories. 401_python_check_python_pkg_setup_execution() {
185 rm -f "${dir}" || die "Deletion of '${dir}' failed" 402 [[ " ${FUNCNAME[@]:1} " =~ " "(python_set_active_version|python_pkg_setup)" " ]] && return
186 ln -s "${dir}-${PYTHON_ABI}" "${dir}" || die "Creation of '${dir}' directory symlink failed" 403
404 if ! has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_PKG_SETUP_EXECUTED}" ]]; then
405 die "python_pkg_setup() not called"
406 fi
407}
408
409# @FUNCTION: python_pkg_setup
410# @DESCRIPTION:
411# Perform sanity checks and initialize environment.
412#
413# This function is exported in EAPI 2 and 3 when PYTHON_USE_WITH or PYTHON_USE_WITH_OR variable
414# is set and always in EAPI >=4. Calling of this function is mandatory in EAPI >=4.
415python_pkg_setup() {
416 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
417 die "${FUNCNAME}() can be used only in pkg_setup() phase"
418 fi
419
420 if [[ "$#" -ne 0 ]]; then
421 die "${FUNCNAME}() does not accept arguments"
422 fi
423
424 export JYTHON_SYSTEM_CACHEDIR="1"
425 addwrite "${EPREFIX}/var/cache/jython"
426
427 if _python_package_supporting_installation_for_multiple_python_abis; then
428 _python_calculate_PYTHON_ABIS
429 export EPYTHON="$(PYTHON -f)"
430 else
431 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
432 fi
433
434 if ! has "${EAPI:-0}" 0 1 && [[ -n "${PYTHON_USE_WITH}" || -n "${PYTHON_USE_WITH_OR}" ]]; then
435 if [[ "${PYTHON_USE_WITH_OPT}" ]]; then
436 if [[ "${PYTHON_USE_WITH_OPT}" == !* ]]; then
437 use ${PYTHON_USE_WITH_OPT#!} && return
438 else
439 use !${PYTHON_USE_WITH_OPT} && return
440 fi
441 fi
442
443 python_pkg_setup_check_USE_flags() {
444 local python_atom USE_flag
445 python_atom="$(python_get_implementational_package)"
446
447 for USE_flag in ${PYTHON_USE_WITH}; do
448 if ! has_version "${python_atom}[${USE_flag}]"; then
449 eerror "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
450 die "Please rebuild ${python_atom} with the following USE flags enabled: ${PYTHON_USE_WITH}"
451 fi
452 done
453
454 for USE_flag in ${PYTHON_USE_WITH_OR}; do
455 if has_version "${python_atom}[${USE_flag}]"; then
456 return
457 fi
458 done
459
460 if [[ ${PYTHON_USE_WITH_OR} ]]; then
461 eerror "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
462 die "Please rebuild ${python_atom} with at least one of the following USE flags enabled: ${PYTHON_USE_WITH_OR}"
463 fi
464 }
465
466 if _python_package_supporting_installation_for_multiple_python_abis; then
467 PYTHON_SKIP_SANITY_CHECKS="1" python_execute_function -q python_pkg_setup_check_USE_flags
468 else
469 python_pkg_setup_check_USE_flags
470 fi
471
472 unset -f python_pkg_setup_check_USE_flags
473 fi
474
475 PYTHON_PKG_SETUP_EXECUTED="1"
476}
477
478_PYTHON_SHEBANG_BASE_PART_REGEX='^#![[:space:]]*([^[:space:]]*/usr/bin/env[[:space:]]+)?([^[:space:]]*/)?(jython|pypy-c|python)'
479
480# @FUNCTION: python_convert_shebangs
481# @USAGE: [-q|--quiet] [-r|--recursive] [-x|--only-executables] [--] <Python_ABI|Python_version> <file|directory> [files|directories]
482# @DESCRIPTION:
483# Convert shebangs in specified files. Directories can be specified only with --recursive option.
484python_convert_shebangs() {
485 _python_check_python_pkg_setup_execution
486
487 local argument file files=() only_executables="0" python_interpreter quiet="0" recursive="0" shebangs_converted="0"
488
489 while (($#)); do
490 case "$1" in
491 -r|--recursive)
492 recursive="1"
493 ;;
494 -q|--quiet)
495 quiet="1"
496 ;;
497 -x|--only-executables)
498 only_executables="1"
499 ;;
500 --)
501 shift
502 break
503 ;;
504 -*)
505 die "${FUNCNAME}(): Unrecognized option '$1'"
506 ;;
507 *)
508 break
509 ;;
510 esac
511 shift
512 done
513
514 if [[ "$#" -eq 0 ]]; then
515 die "${FUNCNAME}(): Missing Python version and files or directories"
516 elif [[ "$#" -eq 1 ]]; then
517 die "${FUNCNAME}(): Missing files or directories"
518 fi
519
520 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
521 python_interpreter="$(PYTHON "$1")"
522 else
523 python_interpreter="python$1"
524 fi
525 shift
526
527 for argument in "$@"; do
528 if [[ ! -e "${argument}" ]]; then
529 die "${FUNCNAME}(): '${argument}' does not exist"
530 elif [[ -f "${argument}" ]]; then
531 files+=("${argument}")
532 elif [[ -d "${argument}" ]]; then
533 if [[ "${recursive}" == "1" ]]; then
534 while read -d $'\0' -r file; do
535 files+=("${file}")
536 done < <(find "${argument}" $([[ "${only_executables}" == "1" ]] && echo -perm /111) -type f -print0)
537 else
538 die "${FUNCNAME}(): '${argument}' is not a regular file"
539 fi
540 else
541 die "${FUNCNAME}(): '${argument}' is not a regular file or a directory"
542 fi
543 done
544
545 for file in "${files[@]}"; do
546 file="${file#./}"
547 [[ "${only_executables}" == "1" && ! -x "${file}" ]] && continue
548
549 if [[ "$(head -n1 "${file}")" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX} ]]; then
550 [[ "$(sed -ne "2p" "${file}")" =~ ^"# Gentoo '".*"' wrapper script generated by python_generate_wrapper_scripts()"$ ]] && continue
551
552 shebangs_converted="1"
553
554 if [[ "${quiet}" == "0" ]]; then
555 einfo "Converting shebang in '${file}'"
556 fi
557
558 sed -e "1s:^#![[:space:]]*\([^[:space:]]*/usr/bin/env[[:space:]]\)\?[[:space:]]*\([^[:space:]]*/\)\?\(jython\|pypy-c\|python\)\([[:digit:]]\+\(\.[[:digit:]]\+\)\?\)\?\(\$\|[[:space:]].*\):#!\1\2${python_interpreter}\6:" -i "${file}" || die "Conversion of shebang in '${file}' failed"
559 fi
560 done
561
562 if [[ "${shebangs_converted}" == "0" ]]; then
563 ewarn "${FUNCNAME}(): Python scripts not found"
564 fi
565}
566
567# @FUNCTION: python_clean_py-compile_files
568# @USAGE: [-q|--quiet]
569# @DESCRIPTION:
570# Clean py-compile files to disable byte-compilation.
571python_clean_py-compile_files() {
572 _python_check_python_pkg_setup_execution
573
574 local file files=() quiet="0"
575
576 while (($#)); do
577 case "$1" in
578 -q|--quiet)
579 quiet="1"
580 ;;
581 -*)
582 die "${FUNCNAME}(): Unrecognized option '$1'"
583 ;;
584 *)
585 die "${FUNCNAME}(): Invalid usage"
586 ;;
587 esac
588 shift
589 done
590
591 while read -d $'\0' -r file; do
592 files+=("${file#./}")
593 done < <(find -name py-compile -type f -print0)
594
595 for file in "${files[@]}"; do
596 if [[ "${quiet}" == "0" ]]; then
597 einfo "Cleaning '${file}' file"
598 fi
599 echo "#!/bin/sh" > "${file}"
600 done
601}
602
603# @FUNCTION: python_clean_installation_image
604# @USAGE: [-q|--quiet]
605# @DESCRIPTION:
606# Delete needless files in installation image.
607#
608# This function can be used only in src_install() phase.
609python_clean_installation_image() {
610 if [[ "${EBUILD_PHASE}" != "install" ]]; then
611 die "${FUNCNAME}() can be used only in src_install() phase"
612 fi
613
614 _python_check_python_pkg_setup_execution
615 _python_initialize_prefix_variables
616
617 local file files=() quiet="0"
618
619 while (($#)); do
620 case "$1" in
621 -q|--quiet)
622 quiet="1"
623 ;;
624 -*)
625 die "${FUNCNAME}(): Unrecognized option '$1'"
626 ;;
627 *)
628 die "${FUNCNAME}(): Invalid usage"
629 ;;
630 esac
631 shift
632 done
633
634 while read -d $'\0' -r file; do
635 files+=("${file}")
636 done < <(find "${ED}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -type f -print0)
637
638 if [[ "${#files[@]}" -gt 0 ]]; then
639 if [[ "${quiet}" == "0" ]]; then
640 ewarn "Deleting byte-compiled Python modules needlessly generated by build system:"
641 fi
642 for file in "${files[@]}"; do
643 if [[ "${quiet}" == "0" ]]; then
644 ewarn " ${file}"
645 fi
646 rm -f "${file}"
647
648 # Delete empty __pycache__ directories.
649 if [[ "${file%/*}" == *"/__pycache__" ]]; then
650 rmdir "${file%/*}" 2> /dev/null
651 fi
652 done
653 fi
654
655 python_clean_sitedirs() {
656 if [[ -d "${ED}$(python_get_sitedir)" ]]; then
657 find "${ED}$(python_get_sitedir)" "(" -name "*.c" -o -name "*.h" -o -name "*.la" ")" -type f -print0 | xargs -0 rm -f
658 fi
659 }
660 if _python_package_supporting_installation_for_multiple_python_abis; then
661 python_execute_function -q python_clean_sitedirs
662 else
663 python_clean_sitedirs
664 fi
665
666 unset -f python_clean_sitedirs
667}
668
669# ================================================================================================
670# =========== FUNCTIONS FOR PACKAGES SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ============
671# ================================================================================================
672
673# @ECLASS-VARIABLE: SUPPORT_PYTHON_ABIS
674# @DESCRIPTION:
675# Set this in EAPI <= 4 to indicate that current package supports installation for
676# multiple Python ABIs.
677
678# @ECLASS-VARIABLE: PYTHON_TESTS_RESTRICTED_ABIS
679# @DESCRIPTION:
680# Space-separated list of Python ABI patterns. Testing in Python ABIs matching any Python ABI
681# patterns specified in this list is skipped.
682
683# @ECLASS-VARIABLE: PYTHON_EXPORT_PHASE_FUNCTIONS
684# @DESCRIPTION:
685# Set this to export phase functions for the following ebuild phases:
686# src_prepare(), src_configure(), src_compile(), src_test(), src_install().
687if ! has "${EAPI:-0}" 0 1; then
688 python_src_prepare() {
689 if [[ "${EBUILD_PHASE}" != "prepare" ]]; then
690 die "${FUNCNAME}() can be used only in src_prepare() phase"
691 fi
692
693 if ! _python_package_supporting_installation_for_multiple_python_abis; then
694 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
695 fi
696
697 _python_check_python_pkg_setup_execution
698
699 if [[ "$#" -ne 0 ]]; then
700 die "${FUNCNAME}() does not accept arguments"
701 fi
702
703 python_copy_sources
704 }
705
706 for python_default_function in src_configure src_compile src_test; do
707 eval "python_${python_default_function}() {
708 if [[ \"\${EBUILD_PHASE}\" != \"${python_default_function#src_}\" ]]; then
709 die \"\${FUNCNAME}() can be used only in ${python_default_function}() phase\"
710 fi
711
712 if ! _python_package_supporting_installation_for_multiple_python_abis; then
713 die \"\${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs\"
714 fi
715
716 _python_check_python_pkg_setup_execution
717
718 python_execute_function -d -s -- \"\$@\"
719 }"
720 done
721 unset python_default_function
722
723 python_src_install() {
724 if [[ "${EBUILD_PHASE}" != "install" ]]; then
725 die "${FUNCNAME}() can be used only in src_install() phase"
726 fi
727
728 if ! _python_package_supporting_installation_for_multiple_python_abis; then
729 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
730 fi
731
732 _python_check_python_pkg_setup_execution
733
734 if has "${EAPI:-0}" 0 1 2 3; then
735 python_execute_function -d -s -- "$@"
736 else
737 python_installation() {
738 emake DESTDIR="${T}/images/${PYTHON_ABI}" install "$@"
739 }
740 python_execute_function -s python_installation "$@"
741 unset python_installation
742
743 python_merge_intermediate_installation_images "${T}/images"
744 fi
745 }
746
747 if [[ -n "${PYTHON_EXPORT_PHASE_FUNCTIONS}" ]]; then
748 EXPORT_FUNCTIONS src_prepare src_configure src_compile src_test src_install
749 fi
750fi
751
752if has "${EAPI:-0}" 0 1 2 3 4; then
753 unset PYTHON_ABIS
754fi
755
756_python_calculate_PYTHON_ABIS() {
757 if ! _python_package_supporting_installation_for_multiple_python_abis; then
758 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
759 fi
760
761 _python_initial_sanity_checks
762
763 if [[ "$(declare -p PYTHON_ABIS 2> /dev/null)" != "declare -x PYTHON_ABIS="* ]] && has "${EAPI:-0}" 0 1 2 3 4; then
764 local PYTHON_ABI
765
766 if [[ "$(declare -p USE_PYTHON 2> /dev/null)" == "declare -x USE_PYTHON="* ]]; then
767 local cpython_enabled="0"
768
769 if [[ -z "${USE_PYTHON}" ]]; then
770 die "USE_PYTHON variable is empty"
771 fi
772
773 for PYTHON_ABI in ${USE_PYTHON}; do
774 if ! has "${PYTHON_ABI}" "${_PYTHON_GLOBALLY_SUPPORTED_ABIS[@]}"; then
775 die "USE_PYTHON variable contains invalid value '${PYTHON_ABI}'"
776 fi
777
778 if has "${PYTHON_ABI}" "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; then
779 cpython_enabled="1"
780 fi
781
782 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
783 export PYTHON_ABIS+="${PYTHON_ABIS:+ }${PYTHON_ABI}"
784 fi
785 done
786
787 if [[ -z "${PYTHON_ABIS//[${IFS}]/}" ]]; then
788 die "USE_PYTHON variable does not enable any Python ABI supported by ${CATEGORY}/${PF}"
789 fi
790
791 if [[ "${cpython_enabled}" == "0" ]]; then
792 die "USE_PYTHON variable does not enable any CPython ABI"
793 fi
794 else
795 local python_version python2_version python3_version support_python_major_version
796
797 if ! has_version "dev-lang/python"; then
798 die "${FUNCNAME}(): 'dev-lang/python' is not installed"
799 fi
800
801 python_version="$("${EPREFIX}/usr/bin/python" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
802
803 if has_version "=dev-lang/python-2*"; then
804 if [[ "$(readlink "${EPREFIX}/usr/bin/python2")" != "python2."* ]]; then
805 die "'${EPREFIX}/usr/bin/python2' is not valid symlink"
806 fi
807
808 python2_version="$("${EPREFIX}/usr/bin/python2" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
809
810 support_python_major_version="0"
811 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
812 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
813 support_python_major_version="1"
814 break
815 fi
816 done
817 if [[ "${support_python_major_version}" == "1" ]]; then
818 if _python_check_python_abi_matching --patterns-list "${python2_version}" "${RESTRICT_PYTHON_ABIS}"; then
819 die "Active version of CPython 2 is not supported by ${CATEGORY}/${PF}"
820 fi
821 else
822 python2_version=""
823 fi
824 fi
825
826 if has_version "=dev-lang/python-3*"; then
827 if [[ "$(readlink "${EPREFIX}/usr/bin/python3")" != "python3."* ]]; then
828 die "'${EPREFIX}/usr/bin/python3' is not valid symlink"
829 fi
830
831 python3_version="$("${EPREFIX}/usr/bin/python3" -c 'from sys import version_info; print(".".join(str(x) for x in version_info[:2]))')"
832
833 support_python_major_version="0"
834 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
835 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
836 support_python_major_version="1"
837 break
838 fi
839 done
840 if [[ "${support_python_major_version}" == "1" ]]; then
841 if _python_check_python_abi_matching --patterns-list "${python3_version}" "${RESTRICT_PYTHON_ABIS}"; then
842 die "Active version of CPython 3 is not supported by ${CATEGORY}/${PF}"
843 fi
844 else
845 python3_version=""
846 fi
847 fi
848
849 if [[ -z "${python2_version}" && -z "${python3_version}" ]]; then
850 eerror "${CATEGORY}/${PF} requires at least one of the following packages:"
851 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}" "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
852 if ! _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${RESTRICT_PYTHON_ABIS}"; then
853 eerror " dev-lang/python:${PYTHON_ABI}"
854 fi
855 done
856 die "No supported version of CPython installed"
857 fi
858
859 if [[ -n "${python2_version}" && "${python_version}" == "2."* && "${python_version}" != "${python2_version}" ]]; then
860 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python2' symlink"
861 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
862 die "Incorrect configuration of Python"
863 fi
864 if [[ -n "${python3_version}" && "${python_version}" == "3."* && "${python_version}" != "${python3_version}" ]]; then
865 eerror "Python wrapper is configured incorrectly or '${EPREFIX}/usr/bin/python3' symlink"
866 eerror "is set incorrectly. Use \`eselect python\` to fix configuration."
867 die "Incorrect configuration of Python"
868 fi
869
870 PYTHON_ABIS="${python2_version} ${python3_version}"
871 PYTHON_ABIS="${PYTHON_ABIS# }"
872 export PYTHON_ABIS="${PYTHON_ABIS% }"
873 fi
874 fi
875
876 _python_final_sanity_checks
877}
878
879_python_prepare_flags() {
880 local array=() deleted_flag element flags new_value old_flag old_value operator pattern prefix variable
881
882 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
883 eval "_PYTHON_SAVED_${variable}=\"\${!variable}\""
884 for prefix in PYTHON_USER_ PYTHON_; do
885 if [[ "$(declare -p ${prefix}${variable} 2> /dev/null)" == "declare -a ${prefix}${variable}="* ]]; then
886 eval "array=(\"\${${prefix}${variable}[@]}\")"
887 for element in "${array[@]}"; do
888 if [[ "${element}" =~ ^${_PYTHON_ABI_PATTERN_REGEX}\ (\+|-)\ .+ ]]; then
889 pattern="${element%% *}"
890 element="${element#* }"
891 operator="${element%% *}"
892 flags="${element#* }"
893 if _python_check_python_abi_matching "${PYTHON_ABI}" "${pattern}"; then
894 if [[ "${operator}" == "+" ]]; then
895 eval "export ${variable}+=\"\${variable:+ }${flags}\""
896 elif [[ "${operator}" == "-" ]]; then
897 flags="${flags// /$'\n'}"
898 old_value="${!variable// /$'\n'}"
899 new_value=""
900 while read old_flag; do
901 while read deleted_flag; do
902 if [[ "${old_flag}" == ${deleted_flag} ]]; then
903 continue 2
904 fi
905 done <<< "${flags}"
906 new_value+="${new_value:+ }${old_flag}"
907 done <<< "${old_value}"
908 eval "export ${variable}=\"\${new_value}\""
909 fi
910 fi
911 else
912 die "Element '${element}' of ${prefix}${variable} array has invalid syntax"
913 fi
914 done
915 elif [[ -n "$(declare -p ${prefix}${variable} 2> /dev/null)" ]]; then
916 die "${prefix}${variable} should be indexed array"
917 fi
918 done
919 done
920}
921
922_python_restore_flags() {
923 local variable
924
925 for variable in CPPFLAGS CFLAGS CXXFLAGS LDFLAGS; do
926 eval "${variable}=\"\${_PYTHON_SAVED_${variable}}\""
927 unset _PYTHON_SAVED_${variable}
928 done
187} 929}
188 930
189# @FUNCTION: python_execute_function 931# @FUNCTION: python_execute_function
190# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] <function> [arguments] 932# @USAGE: [--action-message message] [-d|--default-function] [--failure-message message] [-f|--final-ABI] [--nonfatal] [-q|--quiet] [-s|--separate-build-dirs] [--source-dir source_directory] [--] <function> [arguments]
191# @DESCRIPTION: 933# @DESCRIPTION:
192# Execute specified function for each value of PYTHON_ABIS, optionally passing additional 934# Execute specified function for each value of PYTHON_ABIS, optionally passing additional
193# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables. 935# arguments. The specified function can use PYTHON_ABI and BUILDDIR variables.
194python_execute_function() { 936python_execute_function() {
195 local action action_message action_message_template= default_function="0" failure_message failure_message_template= function nonfatal="0" PYTHON_ABI quiet="0" separate_build_dirs="0" 937 if ! _python_package_supporting_installation_for_multiple_python_abis; then
938 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
939 fi
940
941 _python_check_python_pkg_setup_execution
942 _python_set_color_variables
943
944 local action action_message action_message_template default_function="0" failure_message failure_message_template final_ABI="0" function iterated_PYTHON_ABIS nonfatal="0" previous_directory previous_directory_stack previous_directory_stack_length PYTHON_ABI quiet="0" return_code separate_build_dirs="0" source_dir
196 945
197 while (($#)); do 946 while (($#)); do
198 case "$1" in 947 case "$1" in
199 --action-message) 948 --action-message)
200 action_message_template="$2" 949 action_message_template="$2"
205 ;; 954 ;;
206 --failure-message) 955 --failure-message)
207 failure_message_template="$2" 956 failure_message_template="$2"
208 shift 957 shift
209 ;; 958 ;;
959 -f|--final-ABI)
960 final_ABI="1"
961 ;;
210 --nonfatal) 962 --nonfatal)
211 nonfatal="1" 963 nonfatal="1"
212 ;; 964 ;;
213 -q|--quiet) 965 -q|--quiet)
214 quiet="1" 966 quiet="1"
215 ;; 967 ;;
216 -s|--separate-build-dirs) 968 -s|--separate-build-dirs)
217 separate_build_dirs="1" 969 separate_build_dirs="1"
218 ;; 970 ;;
971 --source-dir)
972 source_dir="$2"
973 shift
974 ;;
975 --)
976 shift
977 break
978 ;;
219 -*) 979 -*)
220 die "${FUNCNAME}(): Unrecognized option $1" 980 die "${FUNCNAME}(): Unrecognized option '$1'"
221 ;; 981 ;;
222 *) 982 *)
223 break 983 break
224 ;; 984 ;;
225 esac 985 esac
226 shift 986 shift
227 done 987 done
228 988
989 if [[ -n "${source_dir}" && "${separate_build_dirs}" == 0 ]]; then
990 die "${FUNCNAME}(): '--source-dir' option can be specified only with '--separate-build-dirs' option"
991 fi
992
229 if [[ "${default_function}" == "0" ]]; then 993 if [[ "${default_function}" == "0" ]]; then
230 if [[ "$#" -eq "0" ]]; then 994 if [[ "$#" -eq 0 ]]; then
231 die "${FUNCNAME}(): Missing function name" 995 die "${FUNCNAME}(): Missing function name"
232 fi 996 fi
233 function="$1" 997 function="$1"
234 shift 998 shift
235 else 999
236 if [[ "$#" -ne "0" ]]; then 1000 if [[ -z "$(type -t "${function}")" ]]; then
237 die "${FUNCNAME}(): --default-function option and function name cannot be specified simultaneously" 1001 die "${FUNCNAME}(): '${function}' function is not defined"
238 fi 1002 fi
1003 else
239 if has "${EAPI:-0}" 0 1; then 1004 if has "${EAPI:-0}" 0 1; then
240 die "${FUNCNAME}(): --default-function option cannot be used in this EAPI" 1005 die "${FUNCNAME}(): '--default-function' option cannot be used in this EAPI"
241 fi 1006 fi
242 1007
243 if [[ "${EBUILD_PHASE}" == "configure" ]]; then 1008 if [[ "${EBUILD_PHASE}" == "configure" ]]; then
244 if has "${EAPI}" 2; then 1009 if has "${EAPI}" 2 3; then
245 python_default_function() { 1010 python_default_function() {
246 econf 1011 econf "$@"
247 } 1012 }
248 else 1013 else
249 python_default_function() { 1014 python_default_function() {
250 nonfatal econf 1015 nonfatal econf "$@"
251 } 1016 }
252 fi 1017 fi
253 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then 1018 elif [[ "${EBUILD_PHASE}" == "compile" ]]; then
254 python_default_function() { 1019 python_default_function() {
255 emake 1020 emake "$@"
256 } 1021 }
257 elif [[ "${EBUILD_PHASE}" == "test" ]]; then 1022 elif [[ "${EBUILD_PHASE}" == "test" ]]; then
258 python_default_function() { 1023 python_default_function() {
1024 # Stolen from portage's _eapi0_src_test()
1025 local emake_cmd="${MAKE:-make} ${MAKEOPTS} ${EXTRA_EMAKE}"
259 if emake -j1 -n check &> /dev/null; then 1026 if ${emake_cmd} -j1 -n check &> /dev/null; then
260 emake -j1 check 1027 ${emake_cmd} -j1 check "$@"
261 elif emake -j1 -n test &> /dev/null; then 1028 elif ${emake_cmd} -j1 -n test &> /dev/null; then
262 emake -j1 test 1029 ${emake_cmd} -j1 test "$@"
263 fi 1030 fi
264 } 1031 }
265 elif [[ "${EBUILD_PHASE}" == "install" ]]; then 1032 elif [[ "${EBUILD_PHASE}" == "install" ]]; then
266 python_default_function() { 1033 python_default_function() {
267 emake DESTDIR="${D}" install 1034 emake DESTDIR="${D}" install "$@"
268 } 1035 }
269 else 1036 else
270 die "${FUNCNAME}(): --default-function option cannot be used in this ebuild phase" 1037 die "${FUNCNAME}(): '--default-function' option cannot be used in this ebuild phase"
271 fi 1038 fi
272 function="python_default_function" 1039 function="python_default_function"
1040 fi
1041
1042 # Ensure that python_execute_function() cannot be directly or indirectly called by python_execute_function().
1043 if _python_abi-specific_local_scope; then
1044 die "${FUNCNAME}(): Invalid call stack"
273 fi 1045 fi
274 1046
275 if [[ "${quiet}" == "0" ]]; then 1047 if [[ "${quiet}" == "0" ]]; then
276 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up" 1048 [[ "${EBUILD_PHASE}" == "setup" ]] && action="Setting up"
277 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking" 1049 [[ "${EBUILD_PHASE}" == "unpack" ]] && action="Unpacking"
284 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation" 1056 [[ "${EBUILD_PHASE}" == "postinst" ]] && action="Postinstallation"
285 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation" 1057 [[ "${EBUILD_PHASE}" == "prerm" ]] && action="Preuninstallation"
286 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation" 1058 [[ "${EBUILD_PHASE}" == "postrm" ]] && action="Postuninstallation"
287 fi 1059 fi
288 1060
289 local RED GREEN BLUE NORMAL 1061 _python_calculate_PYTHON_ABIS
290 if [[ "${NOCOLOR:-false}" =~ ^(false|no)$ ]]; then 1062 if [[ "${final_ABI}" == "1" ]]; then
291 RED=$'\e[1;31m' 1063 iterated_PYTHON_ABIS="$(PYTHON -f --ABI)"
292 GREEN=$'\e[1;32m'
293 BLUE=$'\e[1;34m'
294 NORMAL=$'\e[0m'
295 else 1064 else
296 RED= 1065 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
297 GREEN=
298 BLUE=
299 NORMAL=
300 fi 1066 fi
301
302 validate_PYTHON_ABIS
303 for PYTHON_ABI in ${PYTHON_ABIS}; do 1067 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
1068 if [[ "${EBUILD_PHASE}" == "test" ]] && _python_check_python_abi_matching --patterns-list "${PYTHON_ABI}" "${PYTHON_TESTS_RESTRICTED_ABIS}"; then
1069 if [[ "${quiet}" == "0" ]]; then
1070 echo " ${_GREEN}*${_NORMAL} ${_BLUE}Testing of ${CATEGORY}/${PF} with $(python_get_implementation_and_version) skipped${_NORMAL}"
1071 fi
1072 continue
1073 fi
1074
1075 _python_prepare_flags
1076
304 if [[ "${quiet}" == "0" ]]; then 1077 if [[ "${quiet}" == "0" ]]; then
305 if [[ -n "${action_message_template}" ]]; then 1078 if [[ -n "${action_message_template}" ]]; then
306 action_message="$(eval echo -n "${action_message_template}")" 1079 eval "action_message=\"${action_message_template}\""
307 else 1080 else
308 action_message="${action} of ${CATEGORY}/${PF} with Python ${PYTHON_ABI}..." 1081 action_message="${action} of ${CATEGORY}/${PF} with $(python_get_implementation_and_version)..."
309 fi 1082 fi
310 echo " ${GREEN}*${NORMAL} ${BLUE}${action_message}${NORMAL}" 1083 echo " ${_GREEN}*${_NORMAL} ${_BLUE}${action_message}${_NORMAL}"
311 fi 1084 fi
1085
312 if [[ "${separate_build_dirs}" == "1" ]]; then 1086 if [[ "${separate_build_dirs}" == "1" ]]; then
1087 if [[ -n "${source_dir}" ]]; then
1088 export BUILDDIR="${S}/${source_dir}-${PYTHON_ABI}"
1089 else
313 export BUILDDIR="${S}-${PYTHON_ABI}" 1090 export BUILDDIR="${S}-${PYTHON_ABI}"
1091 fi
314 pushd "${BUILDDIR}" > /dev/null || die "pushd failed" 1092 pushd "${BUILDDIR}" > /dev/null || die "pushd failed"
315 else 1093 else
316 export BUILDDIR="${S}" 1094 export BUILDDIR="${S}"
317 fi 1095 fi
1096
1097 previous_directory="$(pwd)"
1098 previous_directory_stack="$(dirs -p)"
1099 previous_directory_stack_length="$(dirs -p | wc -l)"
1100
1101 if ! has "${EAPI}" 0 1 2 3 && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
1102 EPYTHON="$(PYTHON)" nonfatal "${function}" "$@"
1103 else
318 if ! EPYTHON="$(PYTHON)" "${function}" "$@"; then 1104 EPYTHON="$(PYTHON)" "${function}" "$@"
1105 fi
1106
1107 return_code="$?"
1108
1109 _python_restore_flags
1110
1111 if [[ "${return_code}" -ne 0 ]]; then
319 if [[ -n "${failure_message_template}" ]]; then 1112 if [[ -n "${failure_message_template}" ]]; then
320 failure_message="$(eval echo -n "${failure_message_template}")" 1113 eval "failure_message=\"${failure_message_template}\""
321 else 1114 else
322 failure_message="${action} failed with Python ${PYTHON_ABI} in ${function}() function" 1115 failure_message="${action} failed with $(python_get_implementation_and_version) in ${function}() function"
323 fi 1116 fi
324 if [[ "${nonfatal}" == "1" ]] || has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then 1117
325 local ABI enabled_PYTHON_ABIS 1118 if [[ "${nonfatal}" == "1" ]]; then
326 for ABI in ${PYTHON_ABIS}; do
327 [[ "${ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+=" ${ABI}"
328 done
329 export PYTHON_ABIS="${enabled_PYTHON_ABIS# }"
330 if [[ "${quiet}" == "0" ]]; then 1119 if [[ "${quiet}" == "0" ]]; then
331 ewarn "${RED}${failure_message}${NORMAL}" 1120 ewarn "${failure_message}"
1121 fi
1122 elif [[ "${final_ABI}" == "0" ]] && has "${PYTHON_ABI}" ${FAILURE_TOLERANT_PYTHON_ABIS}; then
1123 if [[ "${EBUILD_PHASE}" != "test" ]] || ! has test-fail-continue ${FEATURES}; then
1124 local enabled_PYTHON_ABIS= other_PYTHON_ABI
1125 for other_PYTHON_ABI in ${PYTHON_ABIS}; do
1126 [[ "${other_PYTHON_ABI}" != "${PYTHON_ABI}" ]] && enabled_PYTHON_ABIS+="${enabled_PYTHON_ABIS:+ }${other_PYTHON_ABI}"
1127 done
1128 export PYTHON_ABIS="${enabled_PYTHON_ABIS}"
1129 fi
1130 if [[ "${quiet}" == "0" ]]; then
1131 ewarn "${failure_message}"
1132 fi
1133 if [[ -z "${PYTHON_ABIS}" ]]; then
1134 die "${function}() function failed with all enabled Python ABIs"
332 fi 1135 fi
333 else 1136 else
334 die "${failure_message}" 1137 die "${failure_message}"
335 fi 1138 fi
336 fi 1139 fi
1140
1141 # Ensure that directory stack has not been decreased.
1142 if [[ "$(dirs -p | wc -l)" -lt "${previous_directory_stack_length}" ]]; then
1143 die "Directory stack decreased illegally"
1144 fi
1145
1146 # Avoid side effects of earlier returning from the specified function.
1147 while [[ "$(dirs -p | wc -l)" -gt "${previous_directory_stack_length}" ]]; do
1148 popd > /dev/null || die "popd failed"
1149 done
1150
1151 # Ensure that the bottom part of directory stack has not been changed. Restore
1152 # previous directory (from before running of the specified function) before
1153 # comparison of directory stacks to avoid mismatch of directory stacks after
1154 # potential using of 'cd' to change current directory. Restoration of previous
1155 # directory allows to safely use 'cd' to change current directory in the
1156 # specified function without changing it back to original directory.
1157 cd "${previous_directory}"
1158 if [[ "$(dirs -p)" != "${previous_directory_stack}" ]]; then
1159 die "Directory stack changed illegally"
1160 fi
1161
337 if [[ "${separate_build_dirs}" == "1" ]]; then 1162 if [[ "${separate_build_dirs}" == "1" ]]; then
338 popd > /dev/null || die "popd failed" 1163 popd > /dev/null || die "popd failed"
339 fi 1164 fi
340 unset BUILDDIR 1165 unset BUILDDIR
341 done 1166 done
343 if [[ "${default_function}" == "1" ]]; then 1168 if [[ "${default_function}" == "1" ]]; then
344 unset -f python_default_function 1169 unset -f python_default_function
345 fi 1170 fi
346} 1171}
347 1172
1173# @FUNCTION: python_copy_sources
1174# @USAGE: <directory="${S}"> [directory]
1175# @DESCRIPTION:
1176# Copy unpacked sources of current package to separate build directory for each Python ABI.
1177python_copy_sources() {
1178 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1179 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1180 fi
348 1181
1182 _python_check_python_pkg_setup_execution
1183
1184 local dir dirs=() PYTHON_ABI
1185
1186 if [[ "$#" -eq 0 ]]; then
1187 if [[ "${WORKDIR}" == "${S}" ]]; then
1188 die "${FUNCNAME}() cannot be used with current value of S variable"
1189 fi
1190 dirs=("${S%/}")
1191 else
1192 dirs=("$@")
1193 fi
1194
1195 _python_calculate_PYTHON_ABIS
1196 for PYTHON_ABI in ${PYTHON_ABIS}; do
1197 for dir in "${dirs[@]}"; do
1198 cp -pr "${dir}" "${dir}-${PYTHON_ABI}" > /dev/null || die "Copying of sources failed"
1199 done
1200 done
1201}
1202
1203# @FUNCTION: python_generate_wrapper_scripts
1204# @USAGE: [-E|--respect-EPYTHON] [-f|--force] [-q|--quiet] [--] <file> [files]
1205# @DESCRIPTION:
1206# Generate wrapper scripts. Existing files are overwritten only with --force option.
1207# If --respect-EPYTHON option is specified, then generated wrapper scripts will
1208# respect EPYTHON variable at run time.
1209#
1210# This function can be used only in src_install() phase.
1211python_generate_wrapper_scripts() {
1212 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1213 die "${FUNCNAME}() can be used only in src_install() phase"
1214 fi
1215
1216 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1217 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1218 fi
1219
1220 _python_check_python_pkg_setup_execution
1221 _python_initialize_prefix_variables
1222
1223 local eselect_python_option file force="0" quiet="0" PYTHON_ABI PYTHON_ABIS_list python2_enabled="0" python3_enabled="0" respect_EPYTHON="0"
1224
1225 while (($#)); do
1226 case "$1" in
1227 -E|--respect-EPYTHON)
1228 respect_EPYTHON="1"
1229 ;;
1230 -f|--force)
1231 force="1"
1232 ;;
1233 -q|--quiet)
1234 quiet="1"
1235 ;;
1236 --)
1237 shift
1238 break
1239 ;;
1240 -*)
1241 die "${FUNCNAME}(): Unrecognized option '$1'"
1242 ;;
1243 *)
1244 break
1245 ;;
1246 esac
1247 shift
1248 done
1249
1250 if [[ "$#" -eq 0 ]]; then
1251 die "${FUNCNAME}(): Missing arguments"
1252 fi
1253
1254 _python_calculate_PYTHON_ABIS
1255 for PYTHON_ABI in "${_CPYTHON2_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1256 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1257 python2_enabled="1"
1258 fi
1259 done
1260 for PYTHON_ABI in "${_CPYTHON3_GLOBALLY_SUPPORTED_ABIS[@]}"; do
1261 if has "${PYTHON_ABI}" ${PYTHON_ABIS}; then
1262 python3_enabled="1"
1263 fi
1264 done
1265
1266 if [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "1" ]]; then
1267 eselect_python_option=
1268 elif [[ "${python2_enabled}" == "1" && "${python3_enabled}" == "0" ]]; then
1269 eselect_python_option="--python2"
1270 elif [[ "${python2_enabled}" == "0" && "${python3_enabled}" == "1" ]]; then
1271 eselect_python_option="--python3"
1272 else
1273 die "${FUNCNAME}(): Unsupported environment"
1274 fi
1275
1276 PYTHON_ABIS_list="$("$(PYTHON -f)" -c "print(', '.join('\"%s\"' % x for x in reversed('${PYTHON_ABIS}'.split())))")"
1277
1278 for file in "$@"; do
1279 if [[ -f "${file}" && "${force}" == "0" ]]; then
1280 die "${FUNCNAME}(): '${file}' already exists"
1281 fi
1282
1283 if [[ "${quiet}" == "0" ]]; then
1284 einfo "Generating '${file#${ED%/}}' wrapper script"
1285 fi
1286
1287 cat << EOF > "${file}"
1288#!/usr/bin/env python
1289# Gentoo '${file##*/}' wrapper script generated by python_generate_wrapper_scripts()
1290
1291import os
1292import re
1293import subprocess
1294import sys
1295
1296cpython_ABI_re = re.compile(r"^(\d+\.\d+)$")
1297jython_ABI_re = re.compile(r"^(\d+\.\d+)-jython$")
1298pypy_ABI_re = re.compile(r"^\d+\.\d+-pypy-(\d+\.\d+)$")
1299cpython_interpreter_re = re.compile(r"^python(\d+\.\d+)$")
1300jython_interpreter_re = re.compile(r"^jython(\d+\.\d+)$")
1301pypy_interpreter_re = re.compile(r"^pypy-c(\d+\.\d+)$")
1302cpython_shebang_re = re.compile(r"^#![ \t]*(?:${EPREFIX}/usr/bin/python|(?:${EPREFIX})?/usr/bin/env[ \t]+(?:${EPREFIX}/usr/bin/)?python)")
1303python_shebang_options_re = re.compile(r"^#![ \t]*${EPREFIX}/usr/bin/(?:jython|pypy-c|python)(?:\d+(?:\.\d+)?)?[ \t]+(-\S)")
1304python_verification_output_re = re.compile("^GENTOO_PYTHON_TARGET_SCRIPT_PATH supported\n$")
1305
1306pypy_versions_mapping = {
1307 "1.5": "2.7"
1308}
1309
1310def get_PYTHON_ABI(python_interpreter):
1311 cpython_matched = cpython_interpreter_re.match(python_interpreter)
1312 jython_matched = jython_interpreter_re.match(python_interpreter)
1313 pypy_matched = pypy_interpreter_re.match(python_interpreter)
1314 if cpython_matched is not None:
1315 PYTHON_ABI = cpython_matched.group(1)
1316 elif jython_matched is not None:
1317 PYTHON_ABI = jython_matched.group(1) + "-jython"
1318 elif pypy_matched is not None:
1319 PYTHON_ABI = pypy_versions_mapping[pypy_matched.group(1)] + "-pypy-" + pypy_matched.group(1)
1320 else:
1321 PYTHON_ABI = None
1322 return PYTHON_ABI
1323
1324def get_python_interpreter(PYTHON_ABI):
1325 cpython_matched = cpython_ABI_re.match(PYTHON_ABI)
1326 jython_matched = jython_ABI_re.match(PYTHON_ABI)
1327 pypy_matched = pypy_ABI_re.match(PYTHON_ABI)
1328 if cpython_matched is not None:
1329 python_interpreter = "python" + cpython_matched.group(1)
1330 elif jython_matched is not None:
1331 python_interpreter = "jython" + jython_matched.group(1)
1332 elif pypy_matched is not None:
1333 python_interpreter = "pypy-c" + pypy_matched.group(1)
1334 else:
1335 python_interpreter = None
1336 return python_interpreter
1337
1338EOF
1339 if [[ "$?" != "0" ]]; then
1340 die "${FUNCNAME}(): Generation of '$1' failed"
1341 fi
1342 if [[ "${respect_EPYTHON}" == "1" ]]; then
1343 cat << EOF >> "${file}"
1344python_interpreter = os.environ.get("EPYTHON")
1345if python_interpreter:
1346 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1347 if PYTHON_ABI is None:
1348 sys.stderr.write("%s: EPYTHON variable has unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1349 sys.exit(1)
1350else:
1351 try:
1352 environment = os.environ.copy()
1353 environment["ROOT"] = "/"
1354 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1355 if eselect_process.wait() != 0:
1356 raise ValueError
1357 except (OSError, ValueError):
1358 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1359 sys.exit(1)
1360
1361 python_interpreter = eselect_process.stdout.read()
1362 if not isinstance(python_interpreter, str):
1363 # Python 3
1364 python_interpreter = python_interpreter.decode()
1365 python_interpreter = python_interpreter.rstrip("\n")
1366
1367 PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1368 if PYTHON_ABI is None:
1369 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1370 sys.exit(1)
1371
1372wrapper_script_path = os.path.realpath(sys.argv[0])
1373target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1374if not os.path.exists(target_executable_path):
1375 sys.stderr.write("%s: '%s' does not exist\n" % (sys.argv[0], target_executable_path))
1376 sys.exit(1)
1377EOF
1378 if [[ "$?" != "0" ]]; then
1379 die "${FUNCNAME}(): Generation of '$1' failed"
1380 fi
1381 else
1382 cat << EOF >> "${file}"
1383try:
1384 environment = os.environ.copy()
1385 environment["ROOT"] = "/"
1386 eselect_process = subprocess.Popen(["${EPREFIX}/usr/bin/eselect", "python", "show"${eselect_python_option:+, $(echo "\"")}${eselect_python_option}${eselect_python_option:+$(echo "\"")}], env=environment, stdout=subprocess.PIPE)
1387 if eselect_process.wait() != 0:
1388 raise ValueError
1389except (OSError, ValueError):
1390 sys.stderr.write("%s: Execution of 'eselect python show${eselect_python_option:+ }${eselect_python_option}' failed\n" % sys.argv[0])
1391 sys.exit(1)
1392
1393python_interpreter = eselect_process.stdout.read()
1394if not isinstance(python_interpreter, str):
1395 # Python 3
1396 python_interpreter = python_interpreter.decode()
1397python_interpreter = python_interpreter.rstrip("\n")
1398
1399PYTHON_ABI = get_PYTHON_ABI(python_interpreter)
1400if PYTHON_ABI is None:
1401 sys.stderr.write("%s: 'eselect python show${eselect_python_option:+ }${eselect_python_option}' printed unrecognized value '%s'\n" % (sys.argv[0], python_interpreter))
1402 sys.exit(1)
1403
1404wrapper_script_path = os.path.realpath(sys.argv[0])
1405for PYTHON_ABI in [PYTHON_ABI, ${PYTHON_ABIS_list}]:
1406 target_executable_path = "%s-%s" % (wrapper_script_path, PYTHON_ABI)
1407 if os.path.exists(target_executable_path):
1408 break
1409else:
1410 sys.stderr.write("%s: No target script exists for '%s'\n" % (sys.argv[0], wrapper_script_path))
1411 sys.exit(1)
1412
1413python_interpreter = get_python_interpreter(PYTHON_ABI)
1414if python_interpreter is None:
1415 sys.stderr.write("%s: Unrecognized Python ABI '%s'\n" % (sys.argv[0], PYTHON_ABI))
1416 sys.exit(1)
1417EOF
1418 if [[ "$?" != "0" ]]; then
1419 die "${FUNCNAME}(): Generation of '$1' failed"
1420 fi
1421 fi
1422 cat << EOF >> "${file}"
1423
1424target_executable = open(target_executable_path, "rb")
1425target_executable_first_line = target_executable.readline()
1426target_executable.close()
1427if not isinstance(target_executable_first_line, str):
1428 # Python 3
1429 target_executable_first_line = target_executable_first_line.decode("utf_8", "replace")
1430
1431options = []
1432python_shebang_options_matched = python_shebang_options_re.match(target_executable_first_line)
1433if python_shebang_options_matched is not None:
1434 options = [python_shebang_options_matched.group(1)]
1435
1436cpython_shebang_matched = cpython_shebang_re.match(target_executable_first_line)
1437
1438if cpython_shebang_matched is not None:
1439 try:
1440 python_interpreter_path = "${EPREFIX}/usr/bin/%s" % python_interpreter
1441 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"] = "1"
1442 python_verification_process = subprocess.Popen([python_interpreter_path, "-c", "pass"], stdout=subprocess.PIPE)
1443 del os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"]
1444 if python_verification_process.wait() != 0:
1445 raise ValueError
1446
1447 python_verification_output = python_verification_process.stdout.read()
1448 if not isinstance(python_verification_output, str):
1449 # Python 3
1450 python_verification_output = python_verification_output.decode()
1451
1452 if not python_verification_output_re.match(python_verification_output):
1453 raise ValueError
1454
1455 if cpython_interpreter_re.match(python_interpreter) is not None:
1456 os.environ["GENTOO_PYTHON_PROCESS_NAME"] = os.path.basename(sys.argv[0])
1457 os.environ["GENTOO_PYTHON_WRAPPER_SCRIPT_PATH"] = sys.argv[0]
1458 os.environ["GENTOO_PYTHON_TARGET_SCRIPT_PATH"] = target_executable_path
1459
1460 if hasattr(os, "execv"):
1461 os.execv(python_interpreter_path, [python_interpreter_path] + options + sys.argv)
1462 else:
1463 sys.exit(subprocess.Popen([python_interpreter_path] + options + sys.argv).wait())
1464 except (KeyboardInterrupt, SystemExit):
1465 raise
1466 except:
1467 pass
1468 for variable in ("GENTOO_PYTHON_PROCESS_NAME", "GENTOO_PYTHON_WRAPPER_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH", "GENTOO_PYTHON_TARGET_SCRIPT_PATH_VERIFICATION"):
1469 if variable in os.environ:
1470 del os.environ[variable]
1471
1472if hasattr(os, "execv"):
1473 os.execv(target_executable_path, sys.argv)
1474else:
1475 sys.exit(subprocess.Popen([target_executable_path] + sys.argv[1:]).wait())
1476EOF
1477 if [[ "$?" != "0" ]]; then
1478 die "${FUNCNAME}(): Generation of '$1' failed"
1479 fi
1480 fperms +x "${file#${ED%/}}" || die "fperms '${file}' failed"
1481 done
1482}
1483
1484# @ECLASS-VARIABLE: PYTHON_VERSIONED_SCRIPTS
1485# @DESCRIPTION:
1486# Array of regular expressions of paths to versioned Python scripts.
1487# Python scripts in /usr/bin and /usr/sbin are versioned by default.
1488
1489# @ECLASS-VARIABLE: PYTHON_VERSIONED_EXECUTABLES
1490# @DESCRIPTION:
1491# Array of regular expressions of paths to versioned executables (including Python scripts).
1492
1493# @ECLASS-VARIABLE: PYTHON_NONVERSIONED_EXECUTABLES
1494# @DESCRIPTION:
1495# Array of regular expressions of paths to nonversioned executables (including Python scripts).
1496
1497# @FUNCTION: python_merge_intermediate_installation_images
1498# @USAGE: [-q|--quiet] [--] <intermediate_installation_images_directory>
1499# @DESCRIPTION:
1500# Merge intermediate installation images into installation image.
1501#
1502# This function can be used only in src_install() phase.
1503python_merge_intermediate_installation_images() {
1504 if [[ "${EBUILD_PHASE}" != "install" ]]; then
1505 die "${FUNCNAME}() can be used only in src_install() phase"
1506 fi
1507
1508 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1509 die "${FUNCNAME}() cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1510 fi
1511
1512 _python_check_python_pkg_setup_execution
1513 _python_initialize_prefix_variables
1514
1515 local absolute_file b file files=() intermediate_installation_images_directory PYTHON_ABI quiet="0" regex shebang version_executable wrapper_scripts=() wrapper_scripts_set=()
1516
1517 while (($#)); do
1518 case "$1" in
1519 -q|--quiet)
1520 quiet="1"
1521 ;;
1522 --)
1523 shift
1524 break
1525 ;;
1526 -*)
1527 die "${FUNCNAME}(): Unrecognized option '$1'"
1528 ;;
1529 *)
1530 break
1531 ;;
1532 esac
1533 shift
1534 done
1535
1536 if [[ "$#" -ne 1 ]]; then
1537 die "${FUNCNAME}() requires 1 argument"
1538 fi
1539
1540 intermediate_installation_images_directory="$1"
1541
1542 if [[ ! -d "${intermediate_installation_images_directory}" ]]; then
1543 die "${FUNCNAME}(): Intermediate installation images directory '${intermediate_installation_images_directory}' does not exist"
1544 fi
1545
1546 _python_calculate_PYTHON_ABIS
1547 if [[ "$(PYTHON -f --ABI)" == 3.* ]]; then
1548 b="b"
1549 fi
1550
1551 while read -d $'\0' -r file; do
1552 files+=("${file}")
1553 done < <("$(PYTHON -f)" -c \
1554"import os
1555import sys
1556
1557if hasattr(sys.stdout, 'buffer'):
1558 # Python 3
1559 stdout = sys.stdout.buffer
1560else:
1561 # Python 2
1562 stdout = sys.stdout
1563
1564files_set = set()
1565
1566os.chdir(${b}'${intermediate_installation_images_directory}')
1567
1568for PYTHON_ABI in ${b}'${PYTHON_ABIS}'.split():
1569 for root, dirs, files in os.walk(PYTHON_ABI + ${b}'${EPREFIX}'):
1570 root = root[len(PYTHON_ABI + ${b}'${EPREFIX}')+1:]
1571 files_set.update(root + ${b}'/' + file for file in files)
1572
1573for file in sorted(files_set):
1574 stdout.write(file)
1575 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of files in intermediate installation images")
1576
1577 for PYTHON_ABI in ${PYTHON_ABIS}; do
1578 if [[ ! -d "${intermediate_installation_images_directory}/${PYTHON_ABI}" ]]; then
1579 die "${FUNCNAME}(): Intermediate installation image for Python ABI '${PYTHON_ABI}' does not exist"
1580 fi
1581
1582 pushd "${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}" > /dev/null || die "pushd failed"
1583
1584 for file in "${files[@]}"; do
1585 version_executable="0"
1586 for regex in "/usr/bin/.*" "/usr/sbin/.*" "${PYTHON_VERSIONED_SCRIPTS[@]}"; do
1587 if [[ "/${file}" =~ ^${regex}$ ]]; then
1588 version_executable="1"
1589 break
1590 fi
1591 done
1592 for regex in "${PYTHON_VERSIONED_EXECUTABLES[@]}"; do
1593 if [[ "/${file}" =~ ^${regex}$ ]]; then
1594 version_executable="2"
1595 break
1596 fi
1597 done
1598 if [[ "${version_executable}" != "0" ]]; then
1599 for regex in "${PYTHON_NONVERSIONED_EXECUTABLES[@]}"; do
1600 if [[ "/${file}" =~ ^${regex}$ ]]; then
1601 version_executable="0"
1602 break
1603 fi
1604 done
1605 fi
1606
1607 [[ "${version_executable}" == "0" ]] && continue
1608
1609 if [[ -L "${file}" ]]; then
1610 absolute_file="$(readlink "${file}")"
1611 if [[ "${absolute_file}" == /* ]]; then
1612 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file##/}"
1613 else
1614 if [[ "${file}" == */* ]]; then
1615 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file%/*}/${absolute_file}"
1616 else
1617 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${absolute_file}"
1618 fi
1619 fi
1620 else
1621 absolute_file="${intermediate_installation_images_directory}/${PYTHON_ABI}${EPREFIX}/${file}"
1622 fi
1623
1624 [[ ! -x "${absolute_file}" ]] && continue
1625
1626 shebang="$(head -n1 "${absolute_file}")" || die "Extraction of shebang from '${absolute_file}' failed"
1627
1628 if [[ "${version_executable}" == "2" ]]; then
1629 wrapper_scripts+=("${ED}${file}")
1630 elif [[ "${version_executable}" == "1" ]]; then
1631 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}([[:digit:]]+(\.[[:digit:]]+)?)?($|[[:space:]]+) ]]; then
1632 wrapper_scripts+=("${ED}${file}")
1633 else
1634 version_executable="0"
1635 fi
1636 fi
1637
1638 [[ "${version_executable}" == "0" ]] && continue
1639
1640 if [[ -e "${file}-${PYTHON_ABI}" ]]; then
1641 die "${FUNCNAME}(): '${EPREFIX}/${file}-${PYTHON_ABI}' already exists"
1642 fi
1643
1644 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
1645
1646 if [[ "${shebang}" =~ ${_PYTHON_SHEBANG_BASE_PART_REGEX}[[:digit:]]*($|[[:space:]]+) ]]; then
1647 if [[ -L "${file}-${PYTHON_ABI}" ]]; then
1648 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${absolute_file}"
1649 else
1650 python_convert_shebangs $([[ "${quiet}" == "1" ]] && echo --quiet) "${PYTHON_ABI}" "${file}-${PYTHON_ABI}"
1651 fi
1652 fi
1653 done
1654
1655 popd > /dev/null || die "popd failed"
1656
1657 # This is per bug #390691, without the duplication refactor, and with
1658 # the 3-way structure per comment #6. This enable users with old
1659 # coreutils to upgrade a lot easier (you need to upgrade python+portage
1660 # before coreutils can be upgraded).
1661 if ROOT="/" has_version '>=sys-apps/coreutils-6.9.90'; then
1662 cp -fr --preserve=all --no-preserve=context "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1663 elif ROOT="/" has_version sys-apps/coreutils; then
1664 cp -fr --preserve=all "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1665 else
1666 cp -fpr "${intermediate_installation_images_directory}/${PYTHON_ABI}/"* "${D}" || die "Merging of intermediate installation image for Python ABI '${PYTHON_ABI} into installation image failed"
1667 fi
1668 done
1669
1670 rm -fr "${intermediate_installation_images_directory}"
1671
1672 if [[ "${#wrapper_scripts[@]}" -ge 1 ]]; then
1673 rm -f "${T}/python_wrapper_scripts"
1674
1675 for file in "${wrapper_scripts[@]}"; do
1676 echo -n "${file}" >> "${T}/python_wrapper_scripts"
1677 echo -en "\x00" >> "${T}/python_wrapper_scripts"
1678 done
1679
1680 while read -d $'\0' -r file; do
1681 wrapper_scripts_set+=("${file}")
1682 done < <("$(PYTHON -f)" -c \
1683"import sys
1684
1685if hasattr(sys.stdout, 'buffer'):
1686 # Python 3
1687 stdout = sys.stdout.buffer
1688else:
1689 # Python 2
1690 stdout = sys.stdout
1691
1692python_wrapper_scripts_file = open('${T}/python_wrapper_scripts', 'rb')
1693files = set(python_wrapper_scripts_file.read().rstrip(${b}'\x00').split(${b}'\x00'))
1694python_wrapper_scripts_file.close()
1695
1696for file in sorted(files):
1697 stdout.write(file)
1698 stdout.write(${b}'\x00')" || die "${FUNCNAME}(): Failure of extraction of set of wrapper scripts")
1699
1700 python_generate_wrapper_scripts $([[ "${quiet}" == "1" ]] && echo --quiet) "${wrapper_scripts_set[@]}"
1701 fi
1702}
1703
1704# ================================================================================================
1705# ========= FUNCTIONS FOR PACKAGES NOT SUPPORTING INSTALLATION FOR MULTIPLE PYTHON ABIS ==========
1706# ================================================================================================
1707
1708unset EPYTHON PYTHON_ABI
1709
1710# @FUNCTION: python_set_active_version
1711# @USAGE: <Python_ABI|2|3>
1712# @DESCRIPTION:
1713# Set locally active version of Python.
1714# If Python_ABI argument is specified, then version of Python corresponding to Python_ABI is used.
1715# If 2 argument is specified, then active version of CPython 2 is used.
1716# If 3 argument is specified, then active version of CPython 3 is used.
1717#
1718# This function can be used only in pkg_setup() phase.
1719python_set_active_version() {
1720 if [[ "${EBUILD_PHASE}" != "setup" ]]; then
1721 die "${FUNCNAME}() can be used only in pkg_setup() phase"
1722 fi
1723
1724 if _python_package_supporting_installation_for_multiple_python_abis; then
1725 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1726 fi
1727
1728 if [[ "$#" -ne 1 ]]; then
1729 die "${FUNCNAME}() requires 1 argument"
1730 fi
1731
1732 _python_initial_sanity_checks
1733
1734 if [[ -z "${PYTHON_ABI}" ]]; then
1735 if [[ -n "$(_python_get_implementation --ignore-invalid "$1")" ]]; then
1736 # PYTHON_ABI variable is intended to be used only in ebuilds/eclasses,
1737 # so it does not need to be exported to subprocesses.
1738 PYTHON_ABI="$1"
1739 if ! _python_implementation && ! has_version "$(python_get_implementational_package)"; then
1740 die "${FUNCNAME}(): '$(python_get_implementational_package)' is not installed"
1741 fi
1742 export EPYTHON="$(PYTHON "$1")"
1743 elif [[ "$1" == "2" ]]; then
1744 if ! _python_implementation && ! has_version "=dev-lang/python-2*"; then
1745 die "${FUNCNAME}(): '=dev-lang/python-2*' is not installed"
1746 fi
1747 export EPYTHON="$(PYTHON -2)"
1748 PYTHON_ABI="${EPYTHON#python}"
1749 PYTHON_ABI="${PYTHON_ABI%%-*}"
1750 elif [[ "$1" == "3" ]]; then
1751 if ! _python_implementation && ! has_version "=dev-lang/python-3*"; then
1752 die "${FUNCNAME}(): '=dev-lang/python-3*' is not installed"
1753 fi
1754 export EPYTHON="$(PYTHON -3)"
1755 PYTHON_ABI="${EPYTHON#python}"
1756 PYTHON_ABI="${PYTHON_ABI%%-*}"
1757 else
1758 die "${FUNCNAME}(): Unrecognized argument '$1'"
1759 fi
1760 fi
1761
1762 _python_final_sanity_checks
1763
1764 # python-updater checks PYTHON_REQUESTED_ACTIVE_VERSION variable.
1765 PYTHON_REQUESTED_ACTIVE_VERSION="$1"
1766}
1767
1768# @FUNCTION: python_need_rebuild
1769# @DESCRIPTION:
1770# Mark current package for rebuilding by python-updater after
1771# switching of active version of Python.
1772python_need_rebuild() {
1773 if _python_package_supporting_installation_for_multiple_python_abis; then
1774 die "${FUNCNAME}() cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
1775 fi
1776
1777 _python_check_python_pkg_setup_execution
1778
1779 if [[ "$#" -ne 0 ]]; then
1780 die "${FUNCNAME}() does not accept arguments"
1781 fi
1782
1783 export PYTHON_NEED_REBUILD="$(PYTHON --ABI)"
1784}
1785
1786# ================================================================================================
1787# ======================================= GETTER FUNCTIONS =======================================
1788# ================================================================================================
1789
1790_PYTHON_ABI_EXTRACTION_COMMAND=\
1791'import platform
1792import sys
1793sys.stdout.write(".".join(str(x) for x in sys.version_info[:2]))
1794if platform.system()[:4] == "Java":
1795 sys.stdout.write("-jython")
1796elif hasattr(platform, "python_implementation") and platform.python_implementation() == "PyPy":
1797 sys.stdout.write("-pypy-" + ".".join(str(x) for x in sys.pypy_version_info[:2]))'
1798
1799_python_get_implementation() {
1800 local ignore_invalid="0"
1801
1802 while (($#)); do
1803 case "$1" in
1804 --ignore-invalid)
1805 ignore_invalid="1"
1806 ;;
1807 --)
1808 shift
1809 break
1810 ;;
1811 -*)
1812 die "${FUNCNAME}(): Unrecognized option '$1'"
1813 ;;
1814 *)
1815 break
1816 ;;
1817 esac
1818 shift
1819 done
1820
1821 if [[ "$#" -ne 1 ]]; then
1822 die "${FUNCNAME}() requires 1 argument"
1823 fi
1824
1825 if [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+$ ]]; then
1826 echo "CPython"
1827 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-jython$ ]]; then
1828 echo "Jython"
1829 elif [[ "$1" =~ ^[[:digit:]]+\.[[:digit:]]+-pypy-[[:digit:]]+\.[[:digit:]]+$ ]]; then
1830 echo "PyPy"
1831 else
1832 if [[ "${ignore_invalid}" == "0" ]]; then
1833 die "${FUNCNAME}(): Unrecognized Python ABI '$1'"
1834 fi
1835 fi
1836}
1837
1838# @FUNCTION: PYTHON
1839# @USAGE: [-2] [-3] [--ABI] [-a|--absolute-path] [-f|--final-ABI] [--] <Python_ABI="${PYTHON_ABI}">
1840# @DESCRIPTION:
1841# Print filename of Python interpreter for specified Python ABI. If Python_ABI argument
1842# is ommitted, then PYTHON_ABI environment variable must be set and is used.
1843# If -2 option is specified, then active version of CPython 2 is used.
1844# If -3 option is specified, then active version of CPython 3 is used.
1845# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1846# -2, -3 and --final-ABI options and Python_ABI argument cannot be specified simultaneously.
1847# If --ABI option is specified, then only specified Python ABI is printed instead of
1848# filename of Python interpreter.
1849# If --absolute-path option is specified, then absolute path to Python interpreter is printed.
1850# --ABI and --absolute-path options cannot be specified simultaneously.
1851PYTHON() {
1852 _python_check_python_pkg_setup_execution
1853
1854 local ABI_output="0" absolute_path_output="0" final_ABI="0" PYTHON_ABI="${PYTHON_ABI}" python_interpreter python2="0" python3="0"
1855
1856 while (($#)); do
1857 case "$1" in
1858 -2)
1859 python2="1"
1860 ;;
1861 -3)
1862 python3="1"
1863 ;;
1864 --ABI)
1865 ABI_output="1"
1866 ;;
1867 -a|--absolute-path)
1868 absolute_path_output="1"
1869 ;;
1870 -f|--final-ABI)
1871 final_ABI="1"
1872 ;;
1873 --)
1874 shift
1875 break
1876 ;;
1877 -*)
1878 die "${FUNCNAME}(): Unrecognized option '$1'"
1879 ;;
1880 *)
1881 break
1882 ;;
1883 esac
1884 shift
1885 done
1886
1887 if [[ "${ABI_output}" == "1" && "${absolute_path_output}" == "1" ]]; then
1888 die "${FUNCNAME}(): '--ABI' and '--absolute-path' options cannot be specified simultaneously"
1889 fi
1890
1891 if [[ "$((${python2} + ${python3} + ${final_ABI}))" -gt 1 ]]; then
1892 die "${FUNCNAME}(): '-2', '-3' or '--final-ABI' options cannot be specified simultaneously"
1893 fi
1894
1895 if [[ "$#" -eq 0 ]]; then
1896 if [[ "${final_ABI}" == "1" ]]; then
1897 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1898 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1899 fi
1900 _python_calculate_PYTHON_ABIS
1901 PYTHON_ABI="${PYTHON_ABIS##* }"
1902 elif [[ "${python2}" == "1" ]]; then
1903 PYTHON_ABI="$(ROOT="/" eselect python show --python2 --ABI)"
1904 if [[ -z "${PYTHON_ABI}" ]]; then
1905 die "${FUNCNAME}(): Active version of CPython 2 not set"
1906 elif [[ "${PYTHON_ABI}" != "2."* ]]; then
1907 die "${FUNCNAME}(): Internal error in \`eselect python show --python2\`"
1908 fi
1909 elif [[ "${python3}" == "1" ]]; then
1910 PYTHON_ABI="$(ROOT="/" eselect python show --python3 --ABI)"
1911 if [[ -z "${PYTHON_ABI}" ]]; then
1912 die "${FUNCNAME}(): Active version of CPython 3 not set"
1913 elif [[ "${PYTHON_ABI}" != "3."* ]]; then
1914 die "${FUNCNAME}(): Internal error in \`eselect python show --python3\`"
1915 fi
1916 elif _python_package_supporting_installation_for_multiple_python_abis; then
1917 if ! _python_abi-specific_local_scope; then
1918 die "${FUNCNAME}() should be used in ABI-specific local scope"
1919 fi
1920 else
1921 PYTHON_ABI="$("${EPREFIX}/usr/bin/python" -c "${_PYTHON_ABI_EXTRACTION_COMMAND}")"
1922 if [[ -z "${PYTHON_ABI}" ]]; then
1923 die "${FUNCNAME}(): Failure of extraction of locally active version of Python"
1924 fi
1925 fi
1926 elif [[ "$#" -eq 1 ]]; then
1927 if [[ "${final_ABI}" == "1" ]]; then
1928 die "${FUNCNAME}(): '--final-ABI' option and Python ABI cannot be specified simultaneously"
1929 fi
1930 if [[ "${python2}" == "1" ]]; then
1931 die "${FUNCNAME}(): '-2' option and Python ABI cannot be specified simultaneously"
1932 fi
1933 if [[ "${python3}" == "1" ]]; then
1934 die "${FUNCNAME}(): '-3' option and Python ABI cannot be specified simultaneously"
1935 fi
1936 PYTHON_ABI="$1"
1937 else
1938 die "${FUNCNAME}(): Invalid usage"
1939 fi
1940
1941 if [[ "${ABI_output}" == "1" ]]; then
1942 echo -n "${PYTHON_ABI}"
1943 return
1944 else
1945 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
1946 python_interpreter="python${PYTHON_ABI}"
1947 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
1948 python_interpreter="jython${PYTHON_ABI%-jython}"
1949 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
1950 python_interpreter="pypy-c${PYTHON_ABI#*-pypy-}"
1951 fi
1952
1953 if [[ "${absolute_path_output}" == "1" ]]; then
1954 echo -n "${EPREFIX}/usr/bin/${python_interpreter}"
1955 else
1956 echo -n "${python_interpreter}"
1957 fi
1958 fi
1959
1960 if [[ -n "${ABI}" && "${ABI}" != "${DEFAULT_ABI}" && "${DEFAULT_ABI}" != "default" ]]; then
1961 echo -n "-${ABI}"
1962 fi
1963}
1964
1965# @FUNCTION: python_get_implementation
1966# @USAGE: [-f|--final-ABI]
1967# @DESCRIPTION:
1968# Print name of Python implementation.
1969# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
1970python_get_implementation() {
1971 _python_check_python_pkg_setup_execution
1972
1973 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
1974
1975 while (($#)); do
1976 case "$1" in
1977 -f|--final-ABI)
1978 final_ABI="1"
1979 ;;
1980 -*)
1981 die "${FUNCNAME}(): Unrecognized option '$1'"
1982 ;;
1983 *)
1984 die "${FUNCNAME}(): Invalid usage"
1985 ;;
1986 esac
1987 shift
1988 done
1989
1990 if [[ "${final_ABI}" == "1" ]]; then
1991 if ! _python_package_supporting_installation_for_multiple_python_abis; then
1992 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
1993 fi
1994 PYTHON_ABI="$(PYTHON -f --ABI)"
1995 else
1996 if _python_package_supporting_installation_for_multiple_python_abis; then
1997 if ! _python_abi-specific_local_scope; then
1998 die "${FUNCNAME}() should be used in ABI-specific local scope"
1999 fi
2000 else
2001 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2002 fi
2003 fi
2004
2005 echo "$(_python_get_implementation "${PYTHON_ABI}")"
2006}
2007
2008# @FUNCTION: python_get_implementational_package
2009# @USAGE: [-f|--final-ABI]
2010# @DESCRIPTION:
2011# Print category, name and slot of package providing Python implementation.
2012# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2013python_get_implementational_package() {
2014 _python_check_python_pkg_setup_execution
2015
2016 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
2017
2018 while (($#)); do
2019 case "$1" in
2020 -f|--final-ABI)
2021 final_ABI="1"
2022 ;;
2023 -*)
2024 die "${FUNCNAME}(): Unrecognized option '$1'"
2025 ;;
2026 *)
2027 die "${FUNCNAME}(): Invalid usage"
2028 ;;
2029 esac
2030 shift
2031 done
2032
2033 if [[ "${final_ABI}" == "1" ]]; then
2034 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2035 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2036 fi
2037 PYTHON_ABI="$(PYTHON -f --ABI)"
2038 else
2039 if _python_package_supporting_installation_for_multiple_python_abis; then
2040 if ! _python_abi-specific_local_scope; then
2041 die "${FUNCNAME}() should be used in ABI-specific local scope"
2042 fi
2043 else
2044 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2045 fi
2046 fi
2047
2048 if [[ "${EAPI:-0}" == "0" ]]; then
2049 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2050 echo "=dev-lang/python-${PYTHON_ABI}*"
2051 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2052 echo "=dev-java/jython-${PYTHON_ABI%-jython}*"
2053 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2054 echo "=dev-python/pypy-${PYTHON_ABI#*-pypy-}*"
2055 fi
2056 else
2057 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2058 echo "dev-lang/python:${PYTHON_ABI}"
2059 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2060 echo "dev-java/jython:${PYTHON_ABI%-jython}"
2061 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2062 echo "dev-python/pypy:${PYTHON_ABI#*-pypy-}"
2063 fi
2064 fi
2065}
2066
2067# @FUNCTION: python_get_includedir
2068# @USAGE: [-b|--base-path] [-f|--final-ABI]
2069# @DESCRIPTION:
2070# Print path to Python include directory.
2071# If --base-path option is specified, then path not prefixed with "/" is printed.
2072# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2073python_get_includedir() {
2074 _python_check_python_pkg_setup_execution
2075
2076 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2077
2078 while (($#)); do
2079 case "$1" in
2080 -b|--base-path)
2081 base_path="1"
2082 ;;
2083 -f|--final-ABI)
2084 final_ABI="1"
2085 ;;
2086 -*)
2087 die "${FUNCNAME}(): Unrecognized option '$1'"
2088 ;;
2089 *)
2090 die "${FUNCNAME}(): Invalid usage"
2091 ;;
2092 esac
2093 shift
2094 done
2095
2096 if [[ "${base_path}" == "0" ]]; then
2097 prefix="/"
2098 fi
2099
2100 if [[ "${final_ABI}" == "1" ]]; then
2101 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2102 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2103 fi
2104 PYTHON_ABI="$(PYTHON -f --ABI)"
2105 else
2106 if _python_package_supporting_installation_for_multiple_python_abis; then
2107 if ! _python_abi-specific_local_scope; then
2108 die "${FUNCNAME}() should be used in ABI-specific local scope"
2109 fi
2110 else
2111 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2112 fi
2113 fi
2114
2115 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2116 echo "${prefix}usr/include/python${PYTHON_ABI}"
2117 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2118 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Include"
2119 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2120 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/include"
2121 fi
2122}
2123
2124# @FUNCTION: python_get_libdir
2125# @USAGE: [-b|--base-path] [-f|--final-ABI]
2126# @DESCRIPTION:
2127# Print path to Python standard library directory.
2128# If --base-path option is specified, then path not prefixed with "/" is printed.
2129# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2130python_get_libdir() {
2131 _python_check_python_pkg_setup_execution
2132
2133 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2134
2135 while (($#)); do
2136 case "$1" in
2137 -b|--base-path)
2138 base_path="1"
2139 ;;
2140 -f|--final-ABI)
2141 final_ABI="1"
2142 ;;
2143 -*)
2144 die "${FUNCNAME}(): Unrecognized option '$1'"
2145 ;;
2146 *)
2147 die "${FUNCNAME}(): Invalid usage"
2148 ;;
2149 esac
2150 shift
2151 done
2152
2153 if [[ "${base_path}" == "0" ]]; then
2154 prefix="/"
2155 fi
2156
2157 if [[ "${final_ABI}" == "1" ]]; then
2158 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2159 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2160 fi
2161 PYTHON_ABI="$(PYTHON -f --ABI)"
2162 else
2163 if _python_package_supporting_installation_for_multiple_python_abis; then
2164 if ! _python_abi-specific_local_scope; then
2165 die "${FUNCNAME}() should be used in ABI-specific local scope"
2166 fi
2167 else
2168 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2169 fi
2170 fi
2171
2172 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2173 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}"
2174 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2175 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib"
2176 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2177 die "${FUNCNAME}(): PyPy has multiple standard library directories"
2178 fi
2179}
2180
2181# @FUNCTION: python_get_sitedir
2182# @USAGE: [-b|--base-path] [-f|--final-ABI]
2183# @DESCRIPTION:
2184# Print path to Python site-packages directory.
2185# If --base-path option is specified, then path not prefixed with "/" is printed.
2186# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2187python_get_sitedir() {
2188 _python_check_python_pkg_setup_execution
2189
2190 local base_path="0" final_ABI="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2191
2192 while (($#)); do
2193 case "$1" in
2194 -b|--base-path)
2195 base_path="1"
2196 ;;
2197 -f|--final-ABI)
2198 final_ABI="1"
2199 ;;
2200 -*)
2201 die "${FUNCNAME}(): Unrecognized option '$1'"
2202 ;;
2203 *)
2204 die "${FUNCNAME}(): Invalid usage"
2205 ;;
2206 esac
2207 shift
2208 done
2209
2210 if [[ "${base_path}" == "0" ]]; then
2211 prefix="/"
2212 fi
2213
2214 if [[ "${final_ABI}" == "1" ]]; then
2215 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2216 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2217 fi
2218 PYTHON_ABI="$(PYTHON -f --ABI)"
2219 else
2220 if _python_package_supporting_installation_for_multiple_python_abis; then
2221 if ! _python_abi-specific_local_scope; then
2222 die "${FUNCNAME}() should be used in ABI-specific local scope"
2223 fi
2224 else
2225 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2226 fi
2227 fi
2228
2229 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2230 echo "${prefix}usr/$(get_libdir)/python${PYTHON_ABI}/site-packages"
2231 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2232 echo "${prefix}usr/share/jython-${PYTHON_ABI%-jython}/Lib/site-packages"
2233 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2234 echo "${prefix}usr/$(get_libdir)/pypy${PYTHON_ABI#*-pypy-}/site-packages"
2235 fi
2236}
2237
2238# @FUNCTION: python_get_library
2239# @USAGE: [-b|--base-path] [-f|--final-ABI] [-l|--linker-option]
2240# @DESCRIPTION:
2241# Print path to Python library.
2242# If --base-path option is specified, then path not prefixed with "/" is printed.
2243# If --linker-option is specified, then "-l${library}" linker option is printed.
2244# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2245python_get_library() {
2246 _python_check_python_pkg_setup_execution
2247
2248 local base_path="0" final_ABI="0" linker_option="0" prefix PYTHON_ABI="${PYTHON_ABI}"
2249
2250 while (($#)); do
2251 case "$1" in
2252 -b|--base-path)
2253 base_path="1"
2254 ;;
2255 -f|--final-ABI)
2256 final_ABI="1"
2257 ;;
2258 -l|--linker-option)
2259 linker_option="1"
2260 ;;
2261 -*)
2262 die "${FUNCNAME}(): Unrecognized option '$1'"
2263 ;;
2264 *)
2265 die "${FUNCNAME}(): Invalid usage"
2266 ;;
2267 esac
2268 shift
2269 done
2270
2271 if [[ "${base_path}" == "0" ]]; then
2272 prefix="/"
2273 fi
2274
2275 if [[ "${base_path}" == "1" && "${linker_option}" == "1" ]]; then
2276 die "${FUNCNAME}(): '--base-path' and '--linker-option' options cannot be specified simultaneously"
2277 fi
2278
2279 if [[ "${final_ABI}" == "1" ]]; then
2280 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2281 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2282 fi
2283 PYTHON_ABI="$(PYTHON -f --ABI)"
2284 else
2285 if _python_package_supporting_installation_for_multiple_python_abis; then
2286 if ! _python_abi-specific_local_scope; then
2287 die "${FUNCNAME}() should be used in ABI-specific local scope"
2288 fi
2289 else
2290 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2291 fi
2292 fi
2293
2294 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2295 if [[ "${linker_option}" == "1" ]]; then
2296 echo "-lpython${PYTHON_ABI}"
2297 else
2298 echo "${prefix}usr/$(get_libdir)/libpython${PYTHON_ABI}$(get_libname)"
2299 fi
2300 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2301 die "${FUNCNAME}(): Jython does not have shared library"
2302 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2303 die "${FUNCNAME}(): PyPy does not have shared library"
2304 fi
2305}
2306
2307# @FUNCTION: python_get_version
2308# @USAGE: [-f|--final-ABI] [-l|--language] [--full] [--major] [--minor] [--micro]
2309# @DESCRIPTION:
2310# Print version of Python implementation.
2311# --full, --major, --minor and --micro options cannot be specified simultaneously.
2312# If --full, --major, --minor and --micro options are not specified, then "${major_version}.${minor_version}" is printed.
2313# If --language option is specified, then version of Python language is printed.
2314# --language and --full options cannot be specified simultaneously.
2315# --language and --micro options cannot be specified simultaneously.
2316# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2317python_get_version() {
2318 _python_check_python_pkg_setup_execution
2319
2320 local final_ABI="0" language="0" language_version full="0" major="0" minor="0" micro="0" PYTHON_ABI="${PYTHON_ABI}" python_command
2321
2322 while (($#)); do
2323 case "$1" in
2324 -f|--final-ABI)
2325 final_ABI="1"
2326 ;;
2327 -l|--language)
2328 language="1"
2329 ;;
2330 --full)
2331 full="1"
2332 ;;
2333 --major)
2334 major="1"
2335 ;;
2336 --minor)
2337 minor="1"
2338 ;;
2339 --micro)
2340 micro="1"
2341 ;;
2342 -*)
2343 die "${FUNCNAME}(): Unrecognized option '$1'"
2344 ;;
2345 *)
2346 die "${FUNCNAME}(): Invalid usage"
2347 ;;
2348 esac
2349 shift
2350 done
2351
2352 if [[ "${final_ABI}" == "1" ]]; then
2353 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2354 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2355 fi
2356 else
2357 if _python_package_supporting_installation_for_multiple_python_abis && ! _python_abi-specific_local_scope; then
2358 die "${FUNCNAME}() should be used in ABI-specific local scope"
2359 fi
2360 fi
2361
2362 if [[ "$((${full} + ${major} + ${minor} + ${micro}))" -gt 1 ]]; then
2363 die "${FUNCNAME}(): '--full', '--major', '--minor' or '--micro' options cannot be specified simultaneously"
2364 fi
2365
2366 if [[ "${language}" == "1" ]]; then
2367 if [[ "${final_ABI}" == "1" ]]; then
2368 PYTHON_ABI="$(PYTHON -f --ABI)"
2369 elif [[ -z "${PYTHON_ABI}" ]]; then
2370 PYTHON_ABI="$(PYTHON --ABI)"
2371 fi
2372 language_version="${PYTHON_ABI%%-*}"
2373 if [[ "${full}" == "1" ]]; then
2374 die "${FUNCNAME}(): '--language' and '--full' options cannot be specified simultaneously"
2375 elif [[ "${major}" == "1" ]]; then
2376 echo "${language_version%.*}"
2377 elif [[ "${minor}" == "1" ]]; then
2378 echo "${language_version#*.}"
2379 elif [[ "${micro}" == "1" ]]; then
2380 die "${FUNCNAME}(): '--language' and '--micro' options cannot be specified simultaneously"
2381 else
2382 echo "${language_version}"
2383 fi
2384 else
2385 if [[ "${full}" == "1" ]]; then
2386 python_command="import sys; print('.'.join(str(x) for x in getattr(sys, 'pypy_version_info', sys.version_info)[:3]))"
2387 elif [[ "${major}" == "1" ]]; then
2388 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[0])"
2389 elif [[ "${minor}" == "1" ]]; then
2390 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[1])"
2391 elif [[ "${micro}" == "1" ]]; then
2392 python_command="import sys; print(getattr(sys, 'pypy_version_info', sys.version_info)[2])"
2393 else
2394 if [[ -n "${PYTHON_ABI}" && "${final_ABI}" == "0" ]]; then
2395 if [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "CPython" ]]; then
2396 echo "${PYTHON_ABI}"
2397 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "Jython" ]]; then
2398 echo "${PYTHON_ABI%-jython}"
2399 elif [[ "$(_python_get_implementation "${PYTHON_ABI}")" == "PyPy" ]]; then
2400 echo "${PYTHON_ABI#*-pypy-}"
2401 fi
2402 return
2403 fi
2404 python_command="from sys import version_info; print('.'.join(str(x) for x in version_info[:2]))"
2405 fi
2406
2407 if [[ "${final_ABI}" == "1" ]]; then
2408 "$(PYTHON -f)" -c "${python_command}"
2409 else
2410 "$(PYTHON ${PYTHON_ABI})" -c "${python_command}"
2411 fi
2412 fi
2413}
2414
2415# @FUNCTION: python_get_implementation_and_version
2416# @USAGE: [-f|--final-ABI]
2417# @DESCRIPTION:
2418# Print name and version of Python implementation.
2419# If version of Python implementation is not bound to version of Python language, then
2420# version of Python language is additionally printed.
2421# If --final-ABI option is specified, then final ABI from the list of enabled ABIs is used.
2422python_get_implementation_and_version() {
2423 _python_check_python_pkg_setup_execution
2424
2425 local final_ABI="0" PYTHON_ABI="${PYTHON_ABI}"
2426
2427 while (($#)); do
2428 case "$1" in
2429 -f|--final-ABI)
2430 final_ABI="1"
2431 ;;
2432 -*)
2433 die "${FUNCNAME}(): Unrecognized option '$1'"
2434 ;;
2435 *)
2436 die "${FUNCNAME}(): Invalid usage"
2437 ;;
2438 esac
2439 shift
2440 done
2441
2442 if [[ "${final_ABI}" == "1" ]]; then
2443 if ! _python_package_supporting_installation_for_multiple_python_abis; then
2444 die "${FUNCNAME}(): '--final-ABI' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2445 fi
2446 PYTHON_ABI="$(PYTHON -f --ABI)"
2447 else
2448 if _python_package_supporting_installation_for_multiple_python_abis; then
2449 if ! _python_abi-specific_local_scope; then
2450 die "${FUNCNAME}() should be used in ABI-specific local scope"
2451 fi
2452 else
2453 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
2454 fi
2455 fi
2456
2457 if [[ "${PYTHON_ABI}" =~ ^[[:digit:]]+\.[[:digit:]]+-[[:alnum:]]+-[[:digit:]]+\.[[:digit:]]+$ ]]; then
2458 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI##*-} (Python ${PYTHON_ABI%%-*})"
2459 else
2460 echo "$(_python_get_implementation "${PYTHON_ABI}") ${PYTHON_ABI%%-*}"
2461 fi
2462}
2463
2464# ================================================================================================
2465# ================================ FUNCTIONS FOR RUNNING OF TESTS ================================
2466# ================================================================================================
2467
349# @ECLASS-VARIABLE: PYTHON_USE_WITH 2468# @ECLASS-VARIABLE: PYTHON_TEST_VERBOSITY
350# @DESCRIPTION: 2469# @DESCRIPTION:
351# Set this to a space separated list of use flags 2470# User-configurable verbosity of tests of Python modules.
352# the python slot in use must be built with. 2471# Supported values: 0, 1, 2, 3, 4.
2472PYTHON_TEST_VERBOSITY="${PYTHON_TEST_VERBOSITY:-1}"
353 2473
354# @ECLASS-VARIABLE: PYTHON_USE_WITH_OR 2474_python_test_hook() {
355# @DESCRIPTION: 2475 if [[ "$#" -ne 1 ]]; then
356# Set this to a space separated list of use flags 2476 die "${FUNCNAME}() requires 1 argument"
357# of which one must be turned on for the slot of 2477 fi
358# in use.
359 2478
360# @ECLASS-VARIABLE: PYTHON_USE_WITH_OPT 2479 if _python_package_supporting_installation_for_multiple_python_abis && [[ "$(type -t "${_PYTHON_TEST_FUNCTION}_$1_hook")" == "function" ]]; then
361# @DESCRIPTION: 2480 "${_PYTHON_TEST_FUNCTION}_$1_hook"
362# Set this if you need to make either PYTHON_USE_WITH or 2481 fi
363# PYTHON_USE_WITH_OR atoms conditional under a use flag. 2482}
364 2483
365# @FUNCTION: python_pkg_setup 2484# @FUNCTION: python_execute_nosetests
2485# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
366# @DESCRIPTION: 2486# @DESCRIPTION:
367# Makes sure PYTHON_USE_WITH or PYTHON_USE_WITH_OR listed use flags 2487# Execute nosetests for all enabled Python ABIs.
368# are respected. Only exported if one of those variables is set. 2488# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
369if ! has ${EAPI:-0} 0 1 && [[ -n ${PYTHON_USE_WITH} || -n ${PYTHON_USE_WITH_OR} ]]; then 2489# python_execute_nosetests_pre_hook() and python_execute_nosetests_post_hook(), if they are defined.
370 python_pkg_setup_fail() { 2490python_execute_nosetests() {
371 eerror "${1}" 2491 _python_check_python_pkg_setup_execution
372 die "${1}" 2492 _python_set_color_variables
2493
2494 local PYTHONPATH_template separate_build_dirs
2495
2496 while (($#)); do
2497 case "$1" in
2498 -P|--PYTHONPATH)
2499 PYTHONPATH_template="$2"
2500 shift
2501 ;;
2502 -s|--separate-build-dirs)
2503 separate_build_dirs="1"
2504 ;;
2505 --)
2506 shift
2507 break
2508 ;;
2509 -*)
2510 die "${FUNCNAME}(): Unrecognized option '$1'"
2511 ;;
2512 *)
2513 break
2514 ;;
2515 esac
2516 shift
2517 done
2518
2519 python_test_function() {
2520 local evaluated_PYTHONPATH
2521
2522 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2523
2524 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook pre
2525
2526 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2527 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2528 PYTHONPATH="${evaluated_PYTHONPATH}" nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2529 else
2530 echo ${_BOLD}nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@"${_NORMAL}
2531 nosetests --verbosity="${PYTHON_TEST_VERBOSITY}" "$@" || return "$?"
2532 fi
2533
2534 _PYTHON_TEST_FUNCTION="python_execute_nosetests" _python_test_hook post
373 } 2535 }
2536 if _python_package_supporting_installation_for_multiple_python_abis; then
2537 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2538 else
2539 if [[ -n "${separate_build_dirs}" ]]; then
2540 die "${FUNCNAME}(): Invalid usage"
2541 fi
2542 python_test_function "$@" || die "Testing failed"
2543 fi
374 2544
375 python_pkg_setup() { 2545 unset -f python_test_function
376 [[ ${PYTHON_USE_WITH_OPT} ]] && use !${PYTHON_USE_WITH_OPT} && return 2546}
377 2547
378 python_version 2548# @FUNCTION: python_execute_py.test
379 local failed 2549# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
380 local pyatom="dev-lang/python:${PYVER}" 2550# @DESCRIPTION:
2551# Execute py.test for all enabled Python ABIs.
2552# In ebuilds of packages supporting installation for multiple Python ABIs, this function calls
2553# python_execute_py.test_pre_hook() and python_execute_py.test_post_hook(), if they are defined.
2554python_execute_py.test() {
2555 _python_check_python_pkg_setup_execution
2556 _python_set_color_variables
381 2557
382 for use in ${PYTHON_USE_WITH}; do 2558 local PYTHONPATH_template separate_build_dirs
383 if ! has_version "${pyatom}[${use}]"; then 2559
384 python_pkg_setup_fail \ 2560 while (($#)); do
385 "Please rebuild ${pyatom} with use flags: ${PYTHON_USE_WITH}" 2561 case "$1" in
2562 -P|--PYTHONPATH)
2563 PYTHONPATH_template="$2"
2564 shift
2565 ;;
2566 -s|--separate-build-dirs)
2567 separate_build_dirs="1"
2568 ;;
2569 --)
2570 shift
2571 break
2572 ;;
2573 -*)
2574 die "${FUNCNAME}(): Unrecognized option '$1'"
2575 ;;
2576 *)
2577 break
2578 ;;
2579 esac
2580 shift
2581 done
2582
2583 python_test_function() {
2584 local evaluated_PYTHONPATH
2585
2586 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2587
2588 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook pre
2589
2590 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2591 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@"${_NORMAL}
2592 PYTHONPATH="${evaluated_PYTHONPATH}" py.test $([[ "${PYTHON_TEST_VERBOSITY}" -ge 2 ]] && echo -v) "$@" || return "$?"
2593 else
2594 echo ${_BOLD}py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@"${_NORMAL}
2595 py.test $([[ "${PYTHON_TEST_VERBOSITY}" -gt 1 ]] && echo -v) "$@" || return "$?"
2596 fi
2597
2598 _PYTHON_TEST_FUNCTION="python_execute_py.test" _python_test_hook post
2599 }
2600 if _python_package_supporting_installation_for_multiple_python_abis; then
2601 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2602 else
2603 if [[ -n "${separate_build_dirs}" ]]; then
2604 die "${FUNCNAME}(): Invalid usage"
2605 fi
2606 python_test_function "$@" || die "Testing failed"
2607 fi
2608
2609 unset -f python_test_function
2610}
2611
2612# @FUNCTION: python_execute_trial
2613# @USAGE: [-P|--PYTHONPATH PYTHONPATH] [-s|--separate-build-dirs] [--] [arguments]
2614# @DESCRIPTION:
2615# Execute trial for all enabled Python ABIs.
2616# In ebuilds of packages supporting installation for multiple Python ABIs, this function
2617# calls python_execute_trial_pre_hook() and python_execute_trial_post_hook(), if they are defined.
2618python_execute_trial() {
2619 _python_check_python_pkg_setup_execution
2620 _python_set_color_variables
2621
2622 local PYTHONPATH_template separate_build_dirs
2623
2624 while (($#)); do
2625 case "$1" in
2626 -P|--PYTHONPATH)
2627 PYTHONPATH_template="$2"
2628 shift
2629 ;;
2630 -s|--separate-build-dirs)
2631 separate_build_dirs="1"
2632 ;;
2633 --)
2634 shift
2635 break
2636 ;;
2637 -*)
2638 die "${FUNCNAME}(): Unrecognized option '$1'"
2639 ;;
2640 *)
2641 break
2642 ;;
2643 esac
2644 shift
2645 done
2646
2647 python_test_function() {
2648 local evaluated_PYTHONPATH
2649
2650 eval "evaluated_PYTHONPATH=\"${PYTHONPATH_template}\""
2651
2652 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook pre
2653
2654 if [[ -n "${evaluated_PYTHONPATH}" ]]; then
2655 echo ${_BOLD}PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2656 PYTHONPATH="${evaluated_PYTHONPATH}" trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2657 else
2658 echo ${_BOLD}trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@"${_NORMAL}
2659 trial $([[ "${PYTHON_TEST_VERBOSITY}" -ge 4 ]] && echo --spew) "$@" || return "$?"
2660 fi
2661
2662 _PYTHON_TEST_FUNCTION="python_execute_trial" _python_test_hook post
2663 }
2664 if _python_package_supporting_installation_for_multiple_python_abis; then
2665 python_execute_function ${separate_build_dirs:+-s} python_test_function "$@"
2666 else
2667 if [[ -n "${separate_build_dirs}" ]]; then
2668 die "${FUNCNAME}(): Invalid usage"
2669 fi
2670 python_test_function "$@" || die "Testing failed"
2671 fi
2672
2673 unset -f python_test_function
2674}
2675
2676# ================================================================================================
2677# ======================= FUNCTIONS FOR HANDLING OF BYTE-COMPILED MODULES ========================
2678# ================================================================================================
2679
2680# @FUNCTION: python_enable_pyc
2681# @DESCRIPTION:
2682# Tell Python to automatically recompile modules to .pyc/.pyo if the
2683# timestamps/version stamps have changed.
2684python_enable_pyc() {
2685 _python_check_python_pkg_setup_execution
2686
2687 if [[ "$#" -ne 0 ]]; then
2688 die "${FUNCNAME}() does not accept arguments"
2689 fi
2690
2691 unset PYTHONDONTWRITEBYTECODE
2692}
2693
2694# @FUNCTION: python_disable_pyc
2695# @DESCRIPTION:
2696# Tell Python not to automatically recompile modules to .pyc/.pyo
2697# even if the timestamps/version stamps do not match. This is done
2698# to protect sandbox.
2699python_disable_pyc() {
2700 _python_check_python_pkg_setup_execution
2701
2702 if [[ "$#" -ne 0 ]]; then
2703 die "${FUNCNAME}() does not accept arguments"
2704 fi
2705
2706 export PYTHONDONTWRITEBYTECODE="1"
2707}
2708
2709_python_clean_compiled_modules() {
2710 _python_initialize_prefix_variables
2711 _python_set_color_variables
2712
2713 [[ "${FUNCNAME[1]}" =~ ^(python_mod_optimize|python_mod_cleanup)$ ]] || die "${FUNCNAME}(): Invalid usage"
2714
2715 local base_module_name compiled_file compiled_files=() dir path py_file root
2716
2717 # Strip trailing slash from EROOT.
2718 root="${EROOT%/}"
2719
2720 for path in "$@"; do
2721 compiled_files=()
2722 if [[ -d "${path}" ]]; then
2723 while read -d $'\0' -r compiled_file; do
2724 compiled_files+=("${compiled_file}")
2725 done < <(find "${path}" "(" -name "*.py[co]" -o -name "*\$py.class" ")" -print0)
2726
2727 if [[ "${EBUILD_PHASE}" == "postrm" ]]; then
2728 # Delete empty child directories.
2729 find "${path}" -type d | sort -r | while read -r dir; do
2730 if rmdir "${dir}" 2> /dev/null; then
2731 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2732 fi
2733 done
2734 fi
2735 elif [[ "${path}" == *.py ]]; then
2736 base_module_name="${path##*/}"
2737 base_module_name="${base_module_name%.py}"
2738 if [[ -d "${path%/*}/__pycache__" ]]; then
2739 while read -d $'\0' -r compiled_file; do
2740 compiled_files+=("${compiled_file}")
2741 done < <(find "${path%/*}/__pycache__" "(" -name "${base_module_name}.*.py[co]" -o -name "${base_module_name}\$py.class" ")" -print0)
2742 fi
2743 compiled_files+=("${path}c" "${path}o" "${path%.py}\$py.class")
2744 fi
2745
2746 for compiled_file in "${compiled_files[@]}"; do
2747 [[ ! -f "${compiled_file}" ]] && continue
2748 dir="${compiled_file%/*}"
2749 dir="${dir##*/}"
2750 if [[ "${compiled_file}" == *.py[co] ]]; then
2751 if [[ "${dir}" == "__pycache__" ]]; then
2752 base_module_name="${compiled_file##*/}"
2753 base_module_name="${base_module_name%.*py[co]}"
2754 base_module_name="${base_module_name%.*}"
2755 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2756 else
2757 py_file="${compiled_file%[co]}"
386 fi 2758 fi
2759 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2760 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2761 else
2762 [[ -f "${py_file}" ]] && continue
2763 fi
2764 echo "${_BLUE}<<< ${compiled_file%[co]}[co]${_NORMAL}"
2765 rm -f "${compiled_file%[co]}"[co]
2766 elif [[ "${compiled_file}" == *\$py.class ]]; then
2767 if [[ "${dir}" == "__pycache__" ]]; then
2768 base_module_name="${compiled_file##*/}"
2769 base_module_name="${base_module_name%\$py.class}"
2770 py_file="${compiled_file%__pycache__/*}${base_module_name}.py"
2771 else
2772 py_file="${compiled_file%\$py.class}.py"
2773 fi
2774 if [[ "${EBUILD_PHASE}" == "postinst" ]]; then
2775 [[ -f "${py_file}" && "${compiled_file}" -nt "${py_file}" ]] && continue
2776 else
2777 [[ -f "${py_file}" ]] && continue
2778 fi
2779 echo "${_BLUE}<<< ${compiled_file}${_NORMAL}"
2780 rm -f "${compiled_file}"
2781 else
2782 die "${FUNCNAME}(): Unrecognized file type: '${compiled_file}'"
2783 fi
2784
2785 # Delete empty parent directories.
2786 dir="${compiled_file%/*}"
2787 while [[ "${dir}" != "${root}" ]]; do
2788 if rmdir "${dir}" 2> /dev/null; then
2789 echo "${_CYAN}<<< ${dir}${_NORMAL}"
2790 else
2791 break
2792 fi
2793 dir="${dir%/*}"
2794 done
387 done 2795 done
388
389 for use in ${PYTHON_USE_WITH_OR}; do
390 if has_version "${pyatom}[${use}]"; then
391 return
392 fi
393 done 2796 done
2797}
394 2798
395 if [[ ${PYTHON_USE_WITH_OR} ]]; then 2799# @FUNCTION: python_mod_optimize
396 python_pkg_setup_fail \ 2800# @USAGE: [--allow-evaluated-non-sitedir-paths] [-d directory] [-f] [-l] [-q] [-x regular_expression] [--] <file|directory> [files|directories]
397 "Please rebuild ${pyatom} with one of: ${PYTHON_USE_WITH_OR}"
398 fi
399 }
400
401 EXPORT_FUNCTIONS pkg_setup
402
403 if [[ ${PYTHON_USE_WITH} ]]; then
404 PYTHON_USE_WITH_ATOM="${PYTHON_ATOM}[${PYTHON_USE_WITH/ /,}]"
405 elif [[ ${PYTHON_USE_WITH_OR} ]]; then
406 PYTHON_USE_WITH_ATOM="|| ( "
407 for use in ${PYTHON_USE_WITH_OR}; do
408 PYTHON_USE_WITH_ATOM="
409 ${PYTHON_USE_WITH_ATOM}
410 ${PYTHON_ATOM}[${use}]"
411 done
412 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_ATOM} )"
413 fi
414 if [[ ${PYTHON_USE_WITH_OPT} ]]; then
415 PYTHON_USE_WITH_ATOM="${PYTHON_USE_WITH_OPT}? ( ${PYTHON_USE_WITH_ATOM} )"
416 fi
417 DEPEND="${PYTHON_USE_WITH_ATOM}"
418 RDEPEND="${PYTHON_USE_WITH_ATOM}"
419fi
420
421# @FUNCTION: python_disable_pyc
422# @DESCRIPTION: 2801# @DESCRIPTION:
423# Tells python not to automatically recompile modules to .pyc/.pyo 2802# Byte-compile specified Python modules.
424# even if the timestamps/version stamps don't match. This is done 2803# -d, -f, -l, -q and -x options passed to this function are passed to compileall.py.
425# to protect sandbox.
426# 2804#
427# note: supported by >=dev-lang/python-2.2.3-r3 only.
428#
429python_disable_pyc() {
430 export PYTHONDONTWRITEBYTECODE=1 # For 2.6 and above
431 export PYTHON_DONTCOMPILE=1 # For 2.5 and below
432}
433
434# @FUNCTION: python_enable_pyc
435# @DESCRIPTION:
436# Tells python to automatically recompile modules to .pyc/.pyo if the
437# timestamps/version stamps change
438python_enable_pyc() {
439 unset PYTHONDONTWRITEBYTECODE
440 unset PYTHON_DONTCOMPILE
441}
442
443python_disable_pyc
444
445# @FUNCTION: python_need_rebuild
446# @DESCRIPTION: Run without arguments, specifies that the package should be
447# rebuilt after a python upgrade.
448python_need_rebuild() {
449 python_version
450 export PYTHON_NEED_REBUILD=${PYVER}
451}
452
453# @FUNCTION: python_get_includedir
454# @DESCRIPTION:
455# Run without arguments, returns the Python include directory.
456python_get_includedir() {
457 if [[ -n "${PYTHON_ABI}" ]]; then
458 echo "/usr/include/python${PYTHON_ABI}"
459 else
460 python_version
461 echo "/usr/include/python${PYVER}"
462 fi
463}
464
465# @FUNCTION: python_get_libdir
466# @DESCRIPTION:
467# Run without arguments, returns the Python library directory.
468python_get_libdir() {
469 if [[ -n "${PYTHON_ABI}" ]]; then
470 echo "/usr/$(get_libdir)/python${PYTHON_ABI}"
471 else
472 python_version
473 echo "/usr/$(get_libdir)/python${PYVER}"
474 fi
475}
476
477# @FUNCTION: python_get_sitedir
478# @DESCRIPTION:
479# Run without arguments, returns the Python site-packages directory.
480python_get_sitedir() {
481 echo "$(python_get_libdir)/site-packages"
482}
483
484# @FUNCTION: python_tkinter_exists
485# @DESCRIPTION:
486# Run without arguments, checks if python was compiled with Tkinter
487# support. If not, prints an error message and dies.
488python_tkinter_exists() {
489 if ! python -c "import Tkinter" >/dev/null 2>&1; then
490 eerror "You need to recompile python with Tkinter support."
491 eerror "Try adding: 'dev-lang/python tk'"
492 eerror "in to /etc/portage/package.use"
493 echo
494 die "missing tkinter support with installed python"
495 fi
496}
497
498# @FUNCTION: python_mod_exists
499# @USAGE: <module>
500# @DESCRIPTION:
501# Run with the module name as an argument. it will check if a
502# python module is installed and loadable. it will return
503# TRUE(0) if the module exists, and FALSE(1) if the module does
504# not exist.
505#
506# Example:
507# if python_mod_exists gtk; then
508# echo "gtk support enabled"
509# fi
510python_mod_exists() {
511 [[ "$1" ]] || die "${FUNCNAME} requires an argument!"
512 python -c "import $1" &>/dev/null
513}
514
515# @FUNCTION: python_mod_compile
516# @USAGE: <file> [more files ...]
517# @DESCRIPTION:
518# Given filenames, it will pre-compile the module's .pyc and .pyo.
519# This function should only be run in pkg_postinst()
520#
521# Example:
522# python_mod_compile /usr/lib/python2.3/site-packages/pygoogle.py
523#
524python_mod_compile() {
525 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
526 die "${FUNCNAME}() cannot be used in this EAPI"
527 fi
528
529 local f myroot myfiles=()
530
531 # Check if phase is pkg_postinst()
532 [[ ${EBUILD_PHASE} != postinst ]] &&\
533 die "${FUNCNAME} should only be run in pkg_postinst()"
534
535 # allow compiling for older python versions
536 if [[ "${PYTHON_OVERRIDE_PYVER}" ]]; then
537 PYVER=${PYTHON_OVERRIDE_PYVER}
538 else
539 python_version
540 fi
541
542 # strip trailing slash
543 myroot="${ROOT%/}"
544
545 # respect ROOT
546 for f in "$@"; do
547 [[ -f "${myroot}/${f}" ]] && myfiles+=("${myroot}/${f}")
548 done
549
550 if ((${#myfiles[@]})); then
551 python${PYVER} ${myroot}/usr/$(get_libdir)/python${PYVER}/py_compile.py "${myfiles[@]}"
552 python${PYVER} -O ${myroot}/usr/$(get_libdir)/python${PYVER}/py_compile.py "${myfiles[@]}" &> /dev/null
553 else
554 ewarn "No files to compile!"
555 fi
556}
557
558# @FUNCTION: python_mod_optimize
559# @USAGE: [options] [directory|file]
560# @DESCRIPTION:
561# If no arguments supplied, it will recompile not recursively all modules
562# under sys.path (eg. /usr/lib/python2.6, /usr/lib/python2.6/site-packages).
563#
564# If supplied with arguments, it will recompile all modules recursively
565# in the supplied directory.
566# This function should only be run in pkg_postinst(). 2805# This function can be used only in pkg_postinst() phase.
567#
568# Options passed to this function are passed to compileall.py.
569#
570# Example:
571# python_mod_optimize ctypesgencore
572python_mod_optimize() { 2806python_mod_optimize() {
573 # Check if phase is pkg_postinst(). 2807 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
574 [[ ${EBUILD_PHASE} != "postinst" ]] && die "${FUNCNAME} should only be run in pkg_postinst()" 2808 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
2809 fi
575 2810
2811 _python_check_python_pkg_setup_execution
2812 _python_initialize_prefix_variables
2813
2814 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
2815 # PYTHON_ABI variable cannot be local in packages not supporting installation for multiple Python ABIs.
2816 local allow_evaluated_non_sitedir_paths="0" dir dirs=() evaluated_dirs=() evaluated_files=() file files=() iterated_PYTHON_ABIS options=() other_dirs=() other_files=() previous_PYTHON_ABI="${PYTHON_ABI}" return_code root site_packages_dirs=() site_packages_files=() stderr stderr_line
2817
2818 if _python_package_supporting_installation_for_multiple_python_abis; then
576 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 2819 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
577 local dir file options=() other_dirs=() other_files=() PYTHON_ABI return_code root site_packages_absolute_dirs=() site_packages_dirs=() site_packages_absolute_files=() site_packages_files=() 2820 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
2821 fi
2822 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
2823 else
2824 if has "${EAPI:-0}" 0 1 2 3; then
2825 iterated_PYTHON_ABIS="${PYTHON_ABI:=$(PYTHON --ABI)}"
2826 else
2827 iterated_PYTHON_ABIS="${PYTHON_ABI}"
2828 fi
2829 fi
578 2830
579 # Strip trailing slash from ROOT. 2831 # Strip trailing slash from EROOT.
580 root="${ROOT%/}" 2832 root="${EROOT%/}"
581 2833
582 # Respect ROOT and options passed to compileall.py.
583 while (($#)); do 2834 while (($#)); do
584 case "$1" in 2835 case "$1" in
2836 --allow-evaluated-non-sitedir-paths)
2837 allow_evaluated_non_sitedir_paths="1"
2838 ;;
585 -l|-f|-q) 2839 -l|-f|-q)
586 options+=("$1") 2840 options+=("$1")
587 ;; 2841 ;;
588 -d|-x) 2842 -d|-x)
589 options+=("$1" "$2") 2843 options+=("$1" "$2")
590 shift 2844 shift
591 ;; 2845 ;;
2846 --)
2847 shift
2848 break
2849 ;;
592 -*) 2850 -*)
593 ewarn "${FUNCNAME}: Ignoring compile option $1" 2851 die "${FUNCNAME}(): Unrecognized option '$1'"
594 ;; 2852 ;;
595 *) 2853 *)
596 if [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
597 die "${FUNCNAME} doesn't support absolute paths of directories/files in site-packages directories"
598 elif [[ "$1" =~ ^/ ]]; then
599 if [[ -d "${root}/$1" ]]; then
600 other_dirs+=("${root}/$1")
601 elif [[ -f "${root}/$1" ]]; then
602 other_files+=("${root}/$1")
603 elif [[ -e "${root}/$1" ]]; then
604 ewarn "'${root}/$1' is not a file or a directory!"
605 else
606 ewarn "'${root}/$1' doesn't exist!"
607 fi
608 else
609 for PYTHON_ABI in ${PYTHON_ABIS}; do
610 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
611 site_packages_dirs+=("$1")
612 break 2854 break
613 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
614 site_packages_files+=("$1")
615 break
616 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
617 ewarn "'$1' is not a file or a directory!"
618 else
619 ewarn "'$1' doesn't exist!"
620 fi
621 done
622 fi
623 ;; 2855 ;;
624 esac 2856 esac
625 shift 2857 shift
626 done 2858 done
627 2859
2860 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
2861 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
2862 fi
2863
2864 if [[ "$#" -eq 0 ]]; then
2865 die "${FUNCNAME}(): Missing files or directories"
2866 fi
2867
2868 while (($#)); do
2869 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
2870 die "${FUNCNAME}(): Invalid argument '$1'"
2871 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
2872 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
2873 elif [[ "$1" =~ ^/ ]]; then
2874 if _python_package_supporting_installation_for_multiple_python_abis; then
2875 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
2876 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
2877 fi
2878 if [[ "$1" != *\$* ]]; then
2879 die "${FUNCNAME}(): '$1' has invalid syntax"
2880 fi
2881 if [[ "$1" == *.py ]]; then
2882 evaluated_files+=("$1")
2883 else
2884 evaluated_dirs+=("$1")
2885 fi
2886 else
2887 if [[ -d "${root}$1" ]]; then
2888 other_dirs+=("${root}$1")
2889 elif [[ -f "${root}$1" ]]; then
2890 other_files+=("${root}$1")
2891 elif [[ -e "${root}$1" ]]; then
2892 eerror "${FUNCNAME}(): '${root}$1' is not a regular file or a directory"
2893 else
2894 eerror "${FUNCNAME}(): '${root}$1' does not exist"
2895 fi
2896 fi
2897 else
2898 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
2899 if [[ -d "${root}$(python_get_sitedir)/$1" ]]; then
2900 site_packages_dirs+=("$1")
2901 break
2902 elif [[ -f "${root}$(python_get_sitedir)/$1" ]]; then
2903 site_packages_files+=("$1")
2904 break
2905 elif [[ -e "${root}$(python_get_sitedir)/$1" ]]; then
2906 eerror "${FUNCNAME}(): '$1' is not a regular file or a directory"
2907 else
2908 eerror "${FUNCNAME}(): '$1' does not exist"
2909 fi
2910 done
2911 fi
2912 shift
2913 done
2914
628 # Set additional options. 2915 # Set additional options.
629 options+=("-q") 2916 options+=("-q")
630 2917
631 for PYTHON_ABI in ${PYTHON_ABIS}; do 2918 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
632 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})); then 2919 if ((${#site_packages_dirs[@]})) || ((${#site_packages_files[@]})) || ((${#evaluated_dirs[@]})) || ((${#evaluated_files[@]})); then
633 return_code="0" 2920 return_code="0"
634 ebegin "Compilation and optimization of Python modules for Python ${PYTHON_ABI}" 2921 stderr=""
635 if ((${#site_packages_dirs[@]})); then 2922 ebegin "Compilation and optimization of Python modules for $(python_get_implementation_and_version)"
2923 if ((${#site_packages_dirs[@]})) || ((${#evaluated_dirs[@]})); then
636 for dir in "${site_packages_dirs[@]}"; do 2924 for dir in "${site_packages_dirs[@]}"; do
637 site_packages_absolute_dirs+=("${root}$(python_get_sitedir)/${dir}") 2925 dirs+=("${root}$(python_get_sitedir)/${dir}")
638 done 2926 done
639 "$(PYTHON)" "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" || return_code="1" 2927 for dir in "${evaluated_dirs[@]}"; do
2928 eval "dirs+=(\"\${root}${dir}\")"
2929 done
2930 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m compileall "${options[@]}" "${dirs[@]}" 2>&1)" || return_code="1"
2931 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
640 "$(PYTHON)" -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${site_packages_absolute_dirs[@]}" &> /dev/null || return_code="1" 2932 "$(PYTHON)" -O -m compileall "${options[@]}" "${dirs[@]}" &> /dev/null || return_code="1"
641 fi 2933 fi
642 if ((${#site_packages_files[@]})); then 2934 _python_clean_compiled_modules "${dirs[@]}"
2935 fi
2936 if ((${#site_packages_files[@]})) || ((${#evaluated_files[@]})); then
643 for file in "${site_packages_files[@]}"; do 2937 for file in "${site_packages_files[@]}"; do
644 site_packages_absolute_files+=("${root}$(python_get_sitedir)/${file}") 2938 files+=("${root}$(python_get_sitedir)/${file}")
645 done 2939 done
646 "$(PYTHON)" "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" || return_code="1" 2940 for file in "${evaluated_files[@]}"; do
647 "$(PYTHON)" -O "${root}$(python_get_libdir)/py_compile.py" "${site_packages_absolute_files[@]}" &> /dev/null || return_code="1" 2941 eval "files+=(\"\${root}${file}\")"
2942 done
2943 stderr+="${stderr:+$'\n'}$("$(PYTHON)" -m py_compile "${files[@]}" 2>&1)" || return_code="1"
2944 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2945 "$(PYTHON)" -O -m py_compile "${files[@]}" &> /dev/null || return_code="1"
2946 fi
2947 _python_clean_compiled_modules "${files[@]}"
648 fi 2948 fi
649 eend "${return_code}" 2949 eend "${return_code}"
2950 if [[ -n "${stderr}" ]]; then
2951 eerror "Syntax errors / warnings in Python modules for $(python_get_implementation_and_version):" &> /dev/null
2952 while read stderr_line; do
2953 eerror " ${stderr_line}"
2954 done <<< "${stderr}"
650 fi 2955 fi
651 unset site_packages_absolute_dirs site_packages_absolute_files 2956 fi
2957 unset dirs files
652 done 2958 done
653 2959
654 # Don't use PYTHON_ABI in next calls to python_get_libdir(). 2960 if _python_package_supporting_installation_for_multiple_python_abis; then
2961 # Restore previous value of PYTHON_ABI.
2962 if [[ -n "${previous_PYTHON_ABI}" ]]; then
2963 PYTHON_ABI="${previous_PYTHON_ABI}"
2964 else
655 unset PYTHON_ABI 2965 unset PYTHON_ABI
2966 fi
2967 fi
656 2968
657 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then 2969 if ((${#other_dirs[@]})) || ((${#other_files[@]})); then
658 return_code="0" 2970 return_code="0"
2971 stderr=""
659 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for Python ${PYVER}..." 2972 ebegin "Compilation and optimization of Python modules placed outside of site-packages directories for $(python_get_implementation_and_version)"
660 if ((${#other_dirs[@]})); then 2973 if ((${#other_dirs[@]})); then
661 python${PYVER} "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" || return_code="1" 2974 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m compileall "${options[@]}" "${other_dirs[@]}" 2>&1)" || return_code="1"
662 python${PYVER} -O "${root}$(python_get_libdir)/compileall.py" "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1" 2975 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2976 "$(PYTHON ${PYTHON_ABI})" -O -m compileall "${options[@]}" "${other_dirs[@]}" &> /dev/null || return_code="1"
2977 fi
2978 _python_clean_compiled_modules "${other_dirs[@]}"
663 fi 2979 fi
664 if ((${#other_files[@]})); then 2980 if ((${#other_files[@]})); then
665 python${PYVER} "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" || return_code="1" 2981 stderr+="${stderr:+$'\n'}$("$(PYTHON ${PYTHON_ABI})" -m py_compile "${other_files[@]}" 2>&1)" || return_code="1"
666 python${PYVER} -O "${root}$(python_get_libdir)/py_compile.py" "${other_files[@]}" &> /dev/null || return_code="1" 2982 if ! has "$(_python_get_implementation "${PYTHON_ABI}")" Jython PyPy; then
2983 "$(PYTHON ${PYTHON_ABI})" -O -m py_compile "${other_files[@]}" &> /dev/null || return_code="1"
2984 fi
2985 _python_clean_compiled_modules "${other_files[@]}"
667 fi 2986 fi
668 eend "${return_code}" 2987 eend "${return_code}"
2988 if [[ -n "${stderr}" ]]; then
2989 eerror "Syntax errors / warnings in Python modules placed outside of site-packages directories for $(python_get_implementation_and_version):" &> /dev/null
2990 while read stderr_line; do
2991 eerror " ${stderr_line}"
2992 done <<< "${stderr}"
669 fi 2993 fi
2994 fi
670 else 2995 else
2996 # Deprecated part of python_mod_optimize()
2997 ewarn
2998 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
2999 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
3000 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
3001 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
3002 ewarn
3003
671 local myroot mydirs=() myfiles=() myopts=() return_code="0" 3004 local myroot mydirs=() myfiles=() myopts=() return_code="0"
672 3005
673 # strip trailing slash 3006 # strip trailing slash
674 myroot="${ROOT%/}" 3007 myroot="${EROOT%/}"
675 3008
676 # respect ROOT and options passed to compileall.py 3009 # respect EROOT and options passed to compileall.py
677 while (($#)); do 3010 while (($#)); do
678 case "$1" in 3011 case "$1" in
679 -l|-f|-q) 3012 -l|-f|-q)
680 myopts+=("$1") 3013 myopts+=("$1")
681 ;; 3014 ;;
682 -d|-x) 3015 -d|-x)
683 myopts+=("$1" "$2") 3016 myopts+=("$1" "$2")
684 shift 3017 shift
685 ;; 3018 ;;
3019 --)
3020 shift
3021 break
3022 ;;
686 -*) 3023 -*)
687 ewarn "${FUNCNAME}: Ignoring compile option $1" 3024 die "${FUNCNAME}(): Unrecognized option '$1'"
688 ;; 3025 ;;
689 *) 3026 *)
690 if [[ -d "${myroot}"/$1 ]]; then 3027 break
691 mydirs+=("${myroot}/$1")
692 elif [[ -f "${myroot}"/$1 ]]; then
693 # Files are passed to python_mod_compile which is ROOT-aware
694 myfiles+=("$1")
695 elif [[ -e "${myroot}/$1" ]]; then
696 ewarn "${myroot}/$1 is not a file or directory!"
697 else
698 ewarn "${myroot}/$1 doesn't exist!"
699 fi
700 ;; 3028 ;;
701 esac 3029 esac
702 shift 3030 shift
703 done 3031 done
704 3032
705 # allow compiling for older python versions 3033 if [[ "$#" -eq 0 ]]; then
706 if [ -n "${PYTHON_OVERRIDE_PYVER}" ]; then 3034 die "${FUNCNAME}(): Missing files or directories"
707 PYVER=${PYTHON_OVERRIDE_PYVER} 3035 fi
3036
3037 while (($#)); do
3038 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
3039 die "${FUNCNAME}(): Invalid argument '$1'"
3040 elif [[ -d "${myroot}/${1#/}" ]]; then
3041 mydirs+=("${myroot}/${1#/}")
3042 elif [[ -f "${myroot}/${1#/}" ]]; then
3043 myfiles+=("${myroot}/${1#/}")
3044 elif [[ -e "${myroot}/${1#/}" ]]; then
3045 eerror "${FUNCNAME}(): ${myroot}/${1#/} is not a regular file or directory"
708 else 3046 else
709 python_version 3047 eerror "${FUNCNAME}(): ${myroot}/${1#/} does not exist"
710 fi 3048 fi
3049 shift
3050 done
711 3051
712 # set additional opts 3052 # set additional opts
713 myopts+=(-q) 3053 myopts+=(-q)
714 3054
715 ebegin "Byte compiling python modules for python-${PYVER} .." 3055 PYTHON_ABI="${PYTHON_ABI:-$(PYTHON --ABI)}"
3056
3057 ebegin "Compilation and optimization of Python modules for $(python_get_implementation) $(python_get_version)"
716 if ((${#mydirs[@]})); then 3058 if ((${#mydirs[@]})); then
717 python${PYVER} \ 3059 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" || return_code="1"
718 "${myroot}"/usr/$(get_libdir)/python${PYVER}/compileall.py \ 3060 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/compileall.py" "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
719 "${myopts[@]}" "${mydirs[@]}" || return_code="1" 3061 _python_clean_compiled_modules "${mydirs[@]}"
720 python${PYVER} -O \
721 "${myroot}"/usr/$(get_libdir)/python${PYVER}/compileall.py \
722 "${myopts[@]}" "${mydirs[@]}" &> /dev/null || return_code="1"
723 fi 3062 fi
724 3063
725 if ((${#myfiles[@]})); then 3064 if ((${#myfiles[@]})); then
3065 "$(PYTHON ${PYTHON_ABI})" "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" || return_code="1"
3066 "$(PYTHON ${PYTHON_ABI})" -O "${myroot}$(python_get_libdir)/py_compile.py" "${myfiles[@]}" &> /dev/null || return_code="1"
726 python_mod_compile "${myfiles[@]}" 3067 _python_clean_compiled_modules "${myfiles[@]}"
727 fi 3068 fi
728 3069
729 eend "${return_code}" 3070 eend "${return_code}"
730 fi 3071 fi
731} 3072}
732 3073
733# @FUNCTION: python_mod_cleanup 3074# @FUNCTION: python_mod_cleanup
734# @USAGE: [directory] 3075# @USAGE: [--allow-evaluated-non-sitedir-paths] [--] <file|directory> [files|directories]
735# @DESCRIPTION: 3076# @DESCRIPTION:
736# Run with optional arguments, where arguments are directories of 3077# Delete orphaned byte-compiled Python modules corresponding to specified Python modules.
737# python modules. If none given, it will look in /usr/lib/python[0-9].[0-9].
738# 3078#
739# It will recursively scan all compiled Python modules in the directories and
740# determine if they are orphaned (i.e. their corresponding .py files are missing.)
741# If they are, then it will remove their corresponding .pyc and .pyo files.
742#
743# This function should only be run in pkg_postrm(). 3079# This function can be used only in pkg_postrm() phase.
744python_mod_cleanup() { 3080python_mod_cleanup() {
745 local PYTHON_ABI SEARCH_PATH=() root src_py 3081 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
3082 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
3083 fi
746 3084
747 # Check if phase is pkg_postrm(). 3085 _python_check_python_pkg_setup_execution
748 [[ ${EBUILD_PHASE} != "postrm" ]] && die "${FUNCNAME} should only be run in pkg_postrm()" 3086 _python_initialize_prefix_variables
749 3087
3088 local allow_evaluated_non_sitedir_paths="0" dir iterated_PYTHON_ABIS PYTHON_ABI="${PYTHON_ABI}" root search_paths=() sitedir
3089
3090 if _python_package_supporting_installation_for_multiple_python_abis; then
3091 if has "${EAPI:-0}" 0 1 2 3 && [[ -z "${PYTHON_ABIS}" ]]; then
3092 die "${FUNCNAME}(): python_pkg_setup() or python_execute_function() not called"
3093 fi
3094 iterated_PYTHON_ABIS="${PYTHON_ABIS}"
3095 else
3096 if has "${EAPI:-0}" 0 1 2 3; then
3097 iterated_PYTHON_ABIS="${PYTHON_ABI:-$(PYTHON --ABI)}"
3098 else
3099 iterated_PYTHON_ABIS="${PYTHON_ABI}"
3100 fi
3101 fi
3102
750 # Strip trailing slash from ROOT. 3103 # Strip trailing slash from EROOT.
751 root="${ROOT%/}" 3104 root="${EROOT%/}"
752 3105
753 if (($#)); then 3106 while (($#)); do
754 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 3107 case "$1" in
3108 --allow-evaluated-non-sitedir-paths)
3109 allow_evaluated_non_sitedir_paths="1"
3110 ;;
3111 --)
3112 shift
3113 break
3114 ;;
3115 -*)
3116 die "${FUNCNAME}(): Unrecognized option '$1'"
3117 ;;
3118 *)
3119 break
3120 ;;
3121 esac
3122 shift
3123 done
3124
3125 if [[ "${allow_evaluated_non_sitedir_paths}" == "1" ]] && ! _python_package_supporting_installation_for_multiple_python_abis; then
3126 die "${FUNCNAME}(): '--allow-evaluated-non-sitedir-paths' option cannot be used in ebuilds of packages not supporting installation for multiple Python ABIs"
3127 fi
3128
3129 if [[ "$#" -eq 0 ]]; then
3130 die "${FUNCNAME}(): Missing files or directories"
3131 fi
3132
3133 if ! has "${EAPI:-0}" 0 1 2 || _python_package_supporting_installation_for_multiple_python_abis || _python_implementation || [[ "${CATEGORY}/${PN}" == "sys-apps/portage" ]]; then
755 while (($#)); do 3134 while (($#)); do
3135 if [[ "$1" =~ ^($|(\.|\.\.|/)($|/)) ]]; then
3136 die "${FUNCNAME}(): Invalid argument '$1'"
756 if [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then 3137 elif ! _python_implementation && [[ "$1" =~ ^/usr/lib(32|64)?/python[[:digit:]]+\.[[:digit:]]+ ]]; then
757 die "${FUNCNAME} doesn't support absolute paths of directories/files in site-packages directories" 3138 die "${FUNCNAME}(): Paths of directories / files in site-packages directories must be relative to site-packages directories"
758 elif [[ "$1" =~ ^/ ]]; then 3139 elif [[ "$1" =~ ^/ ]]; then
759 SEARCH_PATH+=("${root}/${1#/}") 3140 if _python_package_supporting_installation_for_multiple_python_abis; then
3141 if [[ "${allow_evaluated_non_sitedir_paths}" != "1" ]]; then
3142 die "${FUNCNAME}(): Absolute paths cannot be used in ebuilds of packages supporting installation for multiple Python ABIs"
3143 fi
3144 if [[ "$1" != *\$* ]]; then
3145 die "${FUNCNAME}(): '$1' has invalid syntax"
3146 fi
3147 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
3148 eval "search_paths+=(\"\${root}$1\")"
3149 done
760 else 3150 else
3151 search_paths+=("${root}$1")
3152 fi
3153 else
761 for PYTHON_ABI in ${PYTHON_ABIS}; do 3154 for PYTHON_ABI in ${iterated_PYTHON_ABIS}; do
762 SEARCH_PATH+=("${root}$(python_get_sitedir)/$1") 3155 search_paths+=("${root}$(python_get_sitedir)/$1")
763 done 3156 done
764 fi 3157 fi
765 shift 3158 shift
766 done
767 else
768 SEARCH_PATH=("${@#/}")
769 SEARCH_PATH=("${SEARCH_PATH[@]/#/${root}/}")
770 fi
771 else
772 SEARCH_PATH=("${root}"/usr/lib*/python*/site-packages)
773 fi
774
775 for path in "${SEARCH_PATH[@]}"; do
776 [[ ! -d "${path}" ]] && continue
777 einfo "Cleaning orphaned Python bytecode from ${path} .."
778 find "${path}" -name '*.py[co]' -print0 | while read -rd ''; do
779 src_py="${REPLY%[co]}"
780 [[ -f "${src_py}" || (! -f "${src_py}c" && ! -f "${src_py}o") ]] && continue
781 einfo "Purging ${src_py}[co]"
782 rm -f "${src_py}"[co]
783 done 3159 done
3160 else
3161 # Deprecated part of python_mod_cleanup()
3162 ewarn
3163 ewarn "Deprecation Warning: Usage of ${FUNCNAME}() in packages not supporting installation"
3164 ewarn "for multiple Python ABIs in EAPI <=2 is deprecated and will be disallowed on 2011-08-01."
3165 ewarn "Use EAPI >=3 and call ${FUNCNAME}() with paths having appropriate syntax."
3166 ewarn "The ebuild needs to be fixed. Please report a bug, if it has not been already reported."
3167 ewarn
784 3168
785 # Attempt to remove directories that may be empty. 3169 search_paths=("${@#/}")
786 find "${path}" -type d | sort -r | while read -r dir; do 3170 search_paths=("${search_paths[@]/#/${root}/}")
787 rmdir "${dir}" 2>/dev/null && einfo "Removing empty directory ${dir}" 3171 fi
788 done 3172
789 done 3173 _python_clean_compiled_modules "${search_paths[@]}"
790} 3174}
3175
3176# ================================================================================================
3177# ===================================== DEPRECATED FUNCTIONS =====================================
3178# ================================================================================================
3179
3180fi # _PYTHON_ECLASS_INHERITED

Legend:
Removed from v.1.65  
changed lines
  Added in v.1.152

  ViewVC Help
Powered by ViewVC 1.1.20